2004-12-11 Saturday 09:01  geiseri

	Added two examples to the Doxygen documentation.

2004-12-11 Saturday 07:27  geiseri

	Updated Doxyfile.

2004-12-11 Saturday 07:22  geiseri

	Added method throwError(...).
	This method will take an error message and a type and throw a
	complete exception with an error object.  This object has the
	following properties that can be accessed:
	line - the line number the exception happened at.
	sourceid - the source fragment the exception happened in.
	message - the actual error message.
	name - the error type.

	This object can be accessed in both javascript and C++, and
	will be returned as the completion object when there is an
	exception in an executed script.

	Moved all errors in the code to throwError()

2004-12-11 Saturday 07:15  geiseri

	Use extractTQObject here because it is safer.

2004-12-11 Saturday 07:15  geiseri

	Added home directory path, current path, and application directory path.

2004-12-11 Saturday 07:12  geiseri

	Added more verbose documentation on how to use the part interface.

2004-12-11 Saturday 07:11  geiseri

	documentation cleanup

2004-12-11 Saturday 02:25  geiseri

	Actually return the line number that the error happened.

2004-12-10 Friday 13:12  geiseri

	Things that are created via the widgetFactory should be owned in
	javascript.  So when the parent is destroyed so will the children.

2004-12-10 Friday 13:10  geiseri

	Make sure the TDEActionCollection is native, it seems that
	it has no parent so the GC will happily collect it.

2004-12-10 Friday 13:09  geiseri

	Added registration of more proxies.

2004-12-10 Friday 13:07  geiseri

	Small code cleanup.

2004-12-10 Friday 13:03  geiseri

	remove some debug information

2004-12-10 Friday 13:01  geiseri

	Added some debugging info for object ownership.
	Moved the typeName to a pure virtual here.  We already
	broke BC here, and this method is in every child class.

2004-12-10 Friday 12:59  geiseri

	Implemented better TQVariant to JSObject mappings.  The big change here
	that Javascript arrays and Javascript objects can be mapped to TQVariants
	in C++.  Conversions break down as follows:
	TQStringList -> Array of javascript strings.
	TQValueList<TQVariant> -> Array of Javascript values.
	TQMap<TQString,TQVariant> -> Object/Array that has each TQString key as
		a property, and the TQVariant is mapped to a Javascript value.

	From Javascript the conversions are a little different.
	All arrays that have a numeric index will be converted to
	TQValueList<TQVariant> TQVariants.  These can be mapped to both
	TQStringList and to normal TQValueList.  An example would be like this:
	KJS::Value someArrayValue;
	TQStringList strLst = convertToVariant(exec, someArrayValue).toStringList();
	TQValueList<TQVariant> varLst
		= convertToVariant( exec,  someArrayValue).toList();

	Now if the Javascript value is a Javascript object or a map then
	the conversion will go to a TQMap<TQString,TQVariant>.  An example of
	this would be like:
	KJS::Value someJSObject;
	TQMap<TQString,TQVariant> map = convertToVariant(exec,someJSObject)
					.toMap();
	TQString someVal = map["someProp"].toString();

	This is done via some testing of the array and you can trip
	it up in some cases:
	1) If the object is empty, or null will return an empty TQMap
	2) If the object is an array that has the last element null
		then a TQMap will be returned.

	The first case is not much of an issue because an empty variant
	is the same for all types, but the second case can cause
	unexpected results.

	In cases of sparse arrays the empty values will be filled in
	with empty TQVariants in the TQValueList.

2004-12-10 Friday 12:42  geiseri

	Changed the example to actually show off using KJSEmbed.
	Example shows the following:
	1) Embedding KJSEmbed.
	2) Calling Javascript methods from C++.
	3) Transparent mapping of custom javascript objects into TQVariant maps.
	4) Adding widgets to a C++ based form from Javascript.
	5) Execution of a script from outside of the main application.

2004-12-09 Thursday 23:55  geiseri

	removed generated docs from cvs

2004-12-09 Thursday 15:09  geiseri

	torture test for TQFrame, still fails.

2004-12-09 Thursday 15:07  geiseri

	more complete test for arrays

2004-12-08 Wednesday 11:15  geiseri

	Added a TQVariant slot so C++ bindings can easier get more
	complex data types into the bindings.

2004-12-08 Wednesday 11:12  geiseri

	Fixed some logic errors.
	Throw exceptions with meaningful errors.

2004-12-08 Wednesday 11:12  geiseri

	Removed debug information that was screwing with TQVariants.

2004-12-07 Tuesday 20:10  staikos

	compile

2004-12-07 Tuesday 12:02  geiseri

	do not delete a TQWidget if you are painting on it, its rude

2004-12-07 Tuesday 12:01  geiseri

	fix name of include

2004-12-06 Monday 14:08  geiseri

	Moved to new bindings extension class.

2004-12-06 Monday 14:07  geiseri

	With new API TQListViewItem objects now iterate properly.

	TQListView::firstChild() and TQListView::currentSelection now work.
	TQListViewItems can now iterate property.

	The test now shows how to use these methods.


2004-12-06 Monday 14:04  geiseri

	Moved registered bindings to their own baseclass.  This API is not stable
	so it is subject to change.  More documentation on this will follow once
	it is more solid.

2004-12-06 Monday 13:34  geiseri

	Removed autogenerated docs, since the scripts now work to generate them
	property on Qt only and KDE mode.

2004-12-05 Sunday 19:54  geiseri

	Moved TQListViewItem and TQCheckListItem to the object registry.

2004-12-05 Sunday 19:11  geiseri

	Moved bindings to the new object registry.

	The new object registry allows developers to add custom types
	to KJSEmbed when they embed the interpreter into their applications.

	To add a binding you create the binding as binding plugin, but instead
	of using the TDETrader to register the plugin, you call
	JSFactory::registerOpaqueType("Name", new TypeFactory(parent,"name");

	Now KJS can create your type and manipulate it.  This currently supports
	only opaque types, TQObject types are next once  this migration is
	complete.

2004-12-05 Sunday 19:08  geiseri

	Throw errors on type mismatches.  This causes scripts to
	actually give errors where they happen vs at some random
	later point.

2004-12-05 Sunday 10:12  geiseri

	Test for TQFrame

2004-12-04 Saturday 17:57  geiseri

	Do not delete the internal dcop client pointer, it is considered rude.

2004-12-04 Saturday 14:25  geiseri

	Added TQProgressDialog to the list of creatable types.

2004-12-04 Saturday 02:34  geiseri

	QT_NO_ASCII_CAST build fix.

2004-12-04 Saturday 02:25  geiseri

	Gave the KJSEmbed documentation viewer a facelift.
	Runs in Qt only and KDE mode just fine.
	Search is not implemented, but most browser features are.
	Maybe we need to fix up the dump() output and make it
	follow the current KDE color styles?

2004-12-04 Saturday 01:33  geiseri

	Add TQToolBox items to the published children when comming from TQWidgetFactory

2004-12-03 Friday 21:28  geiseri

	Small cleanup.

2004-12-03 Friday 21:27  geiseri

	Add config to Qt only.

2004-12-03 Friday 21:27  geiseri

	dont delete the builting kapplication ptr.

2004-12-03 Friday 21:25  geiseri

	code cleanup.

2004-12-03 Friday 20:07  geiseri

	These are no longer needed.

2004-12-03 Friday 20:06  geiseri

	Added createObject method.

2004-12-03 Friday 20:06  geiseri

	logic fix

2004-12-03 Friday 20:05  geiseri

	Do not delete TQObjects that are managed by their parents.

2004-12-03 Friday 20:04  geiseri

	Added Factory.createObject(classname,args,...) for those coming
	from windows land.

2004-12-03 Friday 20:01  geiseri

	Do not manage TQListView, and ListBox items as the containers will.
	Had to wash this file over with AStyle, it was getting to be a mess.

2004-12-02 Thursday 22:15  geiseri

	note start position

2004-12-02 Thursday 21:50  geiseri

	Added TQRect::contains(...) to Rect class.
	Updated game board to detect objects getting in the target.

2004-12-01 Wednesday 14:45  geiseri

	make 10 items, use TQFrame for formatting.

2004-12-01 Wednesday 11:25  geiseri

	added a small gameboard example

2004-12-01 Wednesday 09:58  geiseri

	Added tests for TQSize, TQPoint and TQRect.

2004-12-01 Wednesday 09:58  geiseri

	Added support for:
	TQPoint
	TQRect
	TQSize

	Cleanup headers in TQPen

	These are all handled as value proxies so they are transparently supported
	in slots, TQObject bindings, and dcop.  These can be used by their variant
	names of Point, Rect and Size respectivly.  Also constructors are provided
	for Point, Rect and Size so you can construct items in one step
	ex:
	var point = new Point(x,y);
	var size = new Size(w,h);
	var rect = new Rect(x,y,w,h);

2004-12-01 Wednesday 09:54  geiseri

	Throw an exception on a handler error so the user can figure out what went wrong.

2004-12-01 Wednesday 09:54  geiseri

	Added drag and drop event handlers.

2004-11-30 Tuesday 17:47  geiseri

	test tdeconfig more robustly.

2004-11-30 Tuesday 12:02  geiseri

	Fixed issue where config files where not reading and writing properly
	When the default args where removed they would pass invalid items to
	the TDEConfig methods.  This would basicly cause the methods to fail
	in strange and entertaining ways.  Since the methods with default
	args had the default args ignored before this really changes nothing
	on the public API.  This will someday change to an opaque proxy
	though and those args will work.

2004-11-30 Tuesday 12:00  geiseri

	save the max input from the dialog

2004-11-30 Tuesday 10:45  geiseri

	Added support for passing TQStringList through slots.  This fixed the problems with TDEConfig bindings not showing up.  It should also fix the problem of not being able to pass StringLists to C++ slots that have been published to javascript.

2004-11-29 Monday 17:41  annma

	add a maximum value that can be changed in config
	config dialog is a bit bloated though now ;-)

2004-11-29 Monday 13:26  geiseri

	Start of TQSettings support for real.  Binding is complete hozed though so it probably needs to be replaced before we release the next release.

2004-11-29 Monday 13:25  geiseri

	Qt only fixes

2004-11-29 Monday 13:22  geiseri

	Qt only fixes.

2004-11-29 Monday 13:22  geiseri

	Remove unused headers.

2004-11-29 Monday 11:14  geiseri

	Update to use KJSEmbed from KDE 3.3 features.

2004-11-28 Sunday 21:38  geiseri

	removed default args, they really screw up TQObject bindings.

2004-11-28 Sunday 21:32  geiseri

	more qtonly config fixes

2004-11-28 Sunday 21:11  geiseri

	Added some help

2004-11-28 Sunday 20:39  geiseri

	added widget extraction methods to cleanup code elsewhere

2004-11-28 Sunday 20:23  geiseri

	Small example application with KJSEmbed:
	This is a small math drill application I wrote for my cousin this weekend.  She is
	having a horrible time of it in math, so I created a simple drill utility for addition and
	subtraction.  Basicly what it does is throws random math problems at you for a
	minute.  The goal is to see how many you can get correct in that time.  This is loosely
	based off of a very foggy memory of a math drill that I did in second grade.  I
	think the important message here is that KJSEmbed could be a powerful tool
	that teachers who are not strong programmers could create learning tools in short
	order.  This particular app took me all of 45 minutes, and after three days of random
	playing of the game (that and khangman) she got up to 38 questions correctly answered
	in a minute up from about 25.  Not sure if its earth shattering, but its an improvement.

	ccmail: annma@kde.org

2004-11-28 Sunday 20:14  geiseri

	Test for Config.

2004-11-28 Sunday 20:13  geiseri

	Splashscreen test.

2004-11-28 Sunday 20:13  geiseri

	Add bindings to Qt only.

2004-11-28 Sunday 20:12  geiseri

	Vain attempt to fix the TQCanvas bindings.  They are no longer crashing, but they are so not implemented they don't do much yet.

2004-11-28 Sunday 20:12  geiseri

	Attempt at unscrewing up this binding.
	It compiles and works slightly more, but it needs a friend seriously.

2004-11-28 Sunday 20:11  geiseri

	TQFrame now actually works as expected.

2004-11-28 Sunday 20:10  geiseri

	Remove dead code.
	Fix stupid corner case where the TQPainter would become invalid and crash kjsembed.

2004-11-28 Sunday 20:09  geiseri

	Compile in Qt Only mode

2004-11-28 Sunday 20:08  geiseri

	Remove dead code.
	Enable working with Qt Only mode.

2004-11-28 Sunday 20:08  geiseri

	Change this so the Config bindings handle all the dirty work.  This
	removes a very strange misbehavior with the Config object when
	used with scripts.
	Started adding support for TQSettings in Qt Only mode, but its disabled for now.

2004-11-28 Sunday 20:07  geiseri

	Change this so the Config bindings handle all the dirty work.  This
	removes a very strange misbehavior with the Config object when
	used with scripts.

2004-11-28 Sunday 20:06  geiseri

	TQSplashScreen works again, the object was there but the bindings where not.
	General code cleanup.
	Made the factory throw some exceptions instead of just warnings.  This will
	allow developers to actually be able to debug their scripts with a nondebug
	version of KJSEmbed.

2004-11-28 Sunday 20:03  geiseri

	Clean up old debug messages.

2004-11-28 Sunday 20:00  geiseri

	Clean up code.
	Remove old debug messages.

2004-11-28 Sunday 19:59  geiseri

	Throw a real exception on a slot error so the script actually knows what the heck went wrong.
	Remove some debug messages that no longer make sense.

2004-11-28 Sunday 19:57  geiseri

	Add bindings to Qt only compile

2004-11-24 Wednesday 19:49  geiseri

	there is suck and there is this, temporary fix until we can get a better solution.

2004-11-24 Wednesday 17:00  geiseri

	sync with zack's tree, builds but sucks

2004-11-24 Wednesday 16:59  geiseri

	sync with zack's tree, isnt building yet

2004-11-24 Wednesday 16:58  geiseri

	cleanup dead code

2004-11-24 Wednesday 11:37  geiseri

	Removed the copy operator and clone functions. They are never called, and if they
	where they would not function as one would expect.

	Check for void types in the destructor.  This should keep anyone from trying
	to delete a void *.

2004-11-24 Wednesday 01:59  staikos

	QT_NO_COMPAT fix (untested, but at least it compiles now):
	int match ( const TQString & str, int index = 0, int * len = 0, bool indexIsStart = TRUE ) const  (obsolete)
	int search ( const TQString & str, int offset = 0, CaretMode caretMode = CaretAtZero ) const

2004-11-24 Wednesday 01:36  geiseri

	remove debug information

2004-11-24 Wednesday 01:28  geiseri

	fixed example

2004-11-24 Wednesday 01:21  geiseri

	globals is now gone.

2004-11-24 Wednesday 01:21  geiseri

	toNative fixes

2004-11-24 Wednesday 01:20  geiseri

	added missing include

2004-11-24 Wednesday 01:19  geiseri

	symbol visibility can work in KDE land now too.

2004-11-24 Wednesday 01:02  geiseri

	toNative<> fixes.

2004-11-24 Wednesday 00:54  geiseri

	More memory management fun:
	1) Removed the any object, it basicly was useless for
	managing pointers.
	2) Changed the opaque proxy to handle the pointers
	internally.  Based heavily on boost::any but focuses on
	pointers only.
	3) Things to note now that KJS is actually managing
	memory.  If you create a TQObject binding but do not store
	it anywhere and let it go out of scope the GC WILL delete
	it.  This may cause some unwanted side effects, so
	please keep track of your objects.
	4) Fixed some casting problems that was causing the
	TQCanvas bindings not to work.  They have not been completely
	solved yet but they are at least not crashing anymore.

	There are still a few crashes, but these should be easier to
	track down now that we have more clear ownership roles.

2004-11-23 Tuesday 18:06  staikos

	warn the users

2004-11-23 Tuesday 11:51  geiseri

	Clarified the object ownership symantics.  This changes the interface a bit so instead of a boolean there is now an enum.  Also the create methods in the factory will automaticly give ownership of pointers created by the factory to KJSEmbed.  Any external proxies created will be owned by the object that creates it.  To change ownership you now use the method JSProxy::setOwner() and JSProxy::owner() to read it.

2004-11-23 Tuesday 11:44  geiseri

	do not screw up dlls

2004-11-23 Tuesday 11:44  geiseri

	header cleanup

2004-11-23 Tuesday 11:43  geiseri

	Share symbol visibility with GCC

2004-11-22 Monday 01:27  zrusin

	We should have a law preventing Ian/Rich from creating Makefile's ;)

2004-11-19 Friday 21:16  bmeyer

	Terminal=0 -> Terminal=false
	Added missing ; to Categories

2004-11-08 Monday 10:12  geiseri

	Qt Events now work on windows.
	GC works on win32.
	NOTE on win32: the standard in/out/err will crash if you do not have
	matching Qt debug and KJSEmbed debug libs.  So if you have a nondebug
	build of Qt NEVER build a debug version of TQJSEmbed.  Gold star for
	MS on this one.

2004-10-03 Sunday 23:25  zrusin

	fixing build

2004-09-23 Thursday 15:51  mlaurent

	CVS_SILENT TQString(i18n(...)) -> i18n(...)

2004-09-01 Wednesday 20:47  geiseri

	more include fixes

2004-09-01 Wednesday 20:43  geiseri

	one more makefile.am fix

2004-09-01 Wednesday 20:42  geiseri

	i just cant get enough of autohell...

2004-09-01 Wednesday 20:36  geiseri

	added qtonly project files.

2004-09-01 Wednesday 20:31  geiseri

	More updates from qtonly version to bring it in sync with KDE version

2004-09-01 Wednesday 20:11  geiseri

	More updates from qtonly version to bring it in sync with KDE version

2004-09-01 Wednesday 20:03  geiseri

	move to plain boost::any.  need to move the deletion of the pointers to the opaque proxies themselves.

2004-09-01 Wednesday 19:58  geiseri

	More updates from qtonly version to bring it in sync with KDE version

2004-09-01 Wednesday 19:52  geiseri

	for some reason vc7 gets confused on casting...

2004-09-01 Wednesday 19:50  geiseri

	qtonly fixes to the globals methods.

2004-09-01 Wednesday 19:49  geiseri

	More updates from qtonly version to bring it in sync with KDE version

2004-09-01 Wednesday 19:00  geiseri

	start merging win32 changes

2004-09-01 Wednesday 10:32  geiseri

	gc test

2004-08-25 Wednesday 11:07  geiseri

	Introduced any object to remove the void* in opaque proxy.
	Introduced the concept of pointer ownership, this api is not yet stable though.

2004-08-20 Friday 16:10  geiseri

	doesnt anyone compile this anymore?

2004-08-16 Monday 19:44  geiseri

	mumble mumble, didnt this compile at one time...

2004-08-16 Monday 09:28  geiseri

	Qt only changes merged into KJSEmbed.

2004-08-16 Monday 09:27  geiseri

	Qt only fixes merged back into KJSEmbed.

2004-08-16 Monday 09:22  geiseri

	more robust exception handling.  soon backtraces.

2004-08-16 Monday 09:22  geiseri

	attempt at custom signatures.

2004-08-16 Monday 09:13  geiseri

	Added KFileItem bindings for doing directory listviews with KFile.

2004-08-16 Monday 08:54  geiseri

	Update dcop test.

2004-08-16 Monday 08:52  geiseri

	moved methods to slots, since when this becomes a nonQt binding the properties will break.

2004-08-16 Monday 08:51  geiseri

	Added iconset bindings.

2004-08-16 Monday 08:48  geiseri

	Reorganization of the bindings here to make Qt/KDE separation easier.

2004-08-16 Monday 08:46  geiseri

	TQWidget and TQObject extraction helper functions.

2004-08-16 Monday 08:45  geiseri

	TQComboBox and TQPopup menu fixes.

2004-07-14 Wednesday 04:31  binner

	CVS_SILENT

2004-06-21 Monday 14:58  binner

	CVS_SILENT No punctuation in command line descriptions

2004-06-21 Monday 06:17  binner

	CVS_SILENT i18n style guide fixes

2004-06-20 Sunday 18:51  rich

	- Added a missing doc file and the test program for qcanvas.

2004-06-20 Sunday 18:49  rich

	- Improvements to the bindingwizard.

	- Start of bindings for TQCanvasXX. These might need to be disabled for the
	  3.3 release but they're a good stress test of the code.

	- Update docs.

	- Added support for TQPoint to jsbinding methods.

2004-06-18 Friday 19:44  rich

	- Added newlines to the documentation to make the html sources more readable.

2004-06-18 Friday 19:33  rich

	- Update docs

2004-06-18 Friday 19:27  rich

	- Added support for the TQStringList parameter argument of the KParts
	  constructors. For now, this can only be used with the full 5 argument
	  forms of the factory's part construction methods. Added the test script
	  from Koos, though it can't be used without an accompanying applet!


2004-06-18 Friday 18:51  rich

	- Updated the qtbindings using the bindwizard. The problems identified in
	  #83427 and my own TQListView testing turned out to be caused by a stupid
	  logic error in the code generated by the XSL. Basically, I forgot that
	  enum values start at 0 even if they're being automagically generated.

2004-06-18 Friday 17:34  rich

	- Reverted the updated TQComboBox bindings. Looks like I need to do some
	  more work on making the XSL binding generator work with the custom
	  bindings code.

	- Added a test case so I don't break this again.


2004-06-12 Saturday 23:03  rich

	- Update docs

2004-06-12 Saturday 22:53  rich

	- Added support for a couple of new types to the extractXX() methods.

	- Major improvements to the binding wizard.

2004-06-12 Saturday 20:51  rich

	- Added action for launching ksnapshot.

2004-06-12 Saturday 20:49  rich

	- Reverted update of the TQListViewItem bindings as it broke things.

2004-06-11 Friday 20:52  rich

	- Handling for slots with signatures xx( const TQTime &) and xx( TQWidget *).


2004-06-11 Friday 19:03  rich

	- Added a way for non-konq users to view the changelog.

2004-06-11 Friday 18:45  rich

	- Disable compilation of the embedding example. This example wasn't
	  written to support compilation with the library (something which
	  needs addressing). Bug #83020, Bug #82991.

	- Added the missing kjs.pro for the qt-only build.


2004-06-06 Sunday 20:58  rich

	- Fixes to make qt-only mode work with the latest changes.

2004-06-06 Sunday 20:42  rich

	- Forgot to add the implementation.

2004-06-06 Sunday 20:40  rich

	- Added support for TQCheckListItem.

	- Regenerated qtbindings using the wizard.

2004-06-06 Sunday 19:37  rich

	- Added support for signals and slots with signature func(const TQTime &)
	  including support for handling them from scripts.

	- Added a check for exceptions occurring in event handlers.


2004-06-06 Sunday 19:03  rich

	- Added a few missing files.

2004-06-06 Sunday 19:00  rich

	- Updated documentation.

2004-06-06 Sunday 18:44  rich

	- Added a binding for the Qt namespace class. This gives scripts access to
	  important constants such as the alignment flags.

	- Added an accessor for the KPropertiesDialog of a URL to NetAccess.

	- Minor fix to the binding wizard to support classes that provide no methods.

	- Added partially complete cropping tool to imunge, along with support for
	  showing the file's properties dialog.

2004-06-06 Sunday 18:10  rich

	CVS_SILENT fix ignores

2004-06-05 Saturday 22:07  rich

	- JSObjectProxy now reuses the same JSObjectEventProxy no matter how many
	  event handlers there are.

2004-06-04 Friday 22:06  rich

	- Added an example script that provides a documentation browser for the
	  qt-only build.

2004-06-04 Friday 21:31  rich

	- Added a script that makes building the qt-only kjsembed easy. All you
	  need to do is ./setup_qtonly in a clean checkout of kjsembed.

	- Fixed some minor issues with types that only showed up because the
	  qt-only tree uses an unusual set of header files. (it's nice that this
	  development has the side effect of making some rare bugs visible).

	- Added a minimal command line for the qt-only build. You can see that
	  things are working by running tests/test_stdio.js. Note that this test
	  script is one of the kde build scripts which shows how easy it should
	  be to migrate between the two.

2004-06-04 Friday 18:52  geiseri

	Resolve conflicts.

2004-05-28 Friday 22:10  rich

	- Updated js reference documentation.

2004-05-28 Friday 22:06  rich

	- Removing docs.

2004-05-28 Friday 21:08  rich

	- Improved the documentation generation.

2004-05-28 Friday 19:55  rich

	- Ensure we always use our debug area in our kdDebug() calls.

2004-05-28 Friday 19:51  rich

	- JS exceptions that occur when a js function has been invoked by a signal
	  are now reported and cleaned up properly.

2004-05-28 Friday 19:15  rich

	- Fixed the problem of the time property of a TQTimeEdit returning -1. This
	  in fact turned out to be a general problem that affects all TQTime
	  properties and was happening because you can't create a Date object in js
	  with just a time in it.


2004-05-27 Thursday 21:05  rich

	- Added the missing mirror() method to the image binding.

	- Added missing icons to imunge.

2004-05-27 Thursday 17:41  rich

	- Added support for passing opaque types as arguments to slots. This is a big
	  win and turned out to be pretty simple once I tracked down a logic error
	  that caused any subsequent args to be ignored. This would all be perfect
	  except for the minor flaw that it doesn't work.

	- Improvements to imunge.
	  - Made it work again after I broke it.
	  - Added support for a bunch more effects.
	  - Shows the filename in the status bar.

	- Added an accessor to the TDEConfig wrapper that lets you obtain an opaque
	  pointer to the TDEConfig object.

	- Updated class docs

2004-05-20 Thursday 20:24  rich

	- Improved the Imunge example code by splitting the image effect handling into
	  a standalone file. In addition, I added support to the GUI for several
	  additional effects and added a toolbar that makes it easy to invoke them.

2004-05-19 Wednesday 21:24  geiseri

	Added the ability to query if a function is available.

2004-05-19 Wednesday 21:17  rich

	- Added support for the selectedItem() method of TQListView then converted the
	  docviewer example to use TQListView.

2004-05-19 Wednesday 20:10  rich

	- Modified the imunge demo to avoid hard-coding the path to the ui.rc file I
	  use here.

2004-05-19 Wednesday 20:08  rich

	- Added support for creating system tray icons from scripts using
	  KSystemTray, and an example that shows how this can be used.

2004-05-19 Wednesday 18:54  rich

	- Fixed a couple of naming errors in TQProcess's signals that resulted from
	  the conversion from TDEProcess.

2004-05-19 Wednesday 18:31  rich

	- Missed this in the last commit.

2004-05-19 Wednesday 18:29  rich

	- Added a new directory for the Qt bindings. This means that these bindings
	  can now be made available for the qtonly version of kjsembed. This also
	  greatly simplifies the structure of the code (basically it's what I should
	  have done initially).

2004-05-19 Wednesday 18:02  rich

	Added something for testing

2004-05-19 Wednesday 16:55  rich

	- Added the first bit of an image manipulation app for kde (using
	  KImageEffect). The app is implemented in javascript.

2004-05-17 Monday 14:52  geiseri

	added the java test applet

2004-05-17 Monday 14:52  geiseri

	I added a test for the args stuff.  Is this correct code?


2004-05-13 Thursday 12:36  geiseri

	Test for slots that use pixmaps

2004-05-13 Thursday 12:35  geiseri

	Qt wants the real thing, not cheap immitations.

	Fixed TQPixmaps in slots.

2004-05-07 Friday 17:13  geiseri

	Added tests to the make file.

2004-05-07 Friday 17:10  geiseri

	Added the C++ based tests used to develop the new part code for manipulating the script engine.

	These need to be refactored, but I hate CPPUnit too much to use that here.

2004-05-05 Wednesday 23:51  geiseri

	Const cleanups
	Fixed accidental memory leak
	Added the following methods to make access of TQVariant based objects
	easier:
	void putVariant( const TQString &valueName, const TQVariant &value);
	TQVariant getVariant( const TQString &valueName ) const;

	Started an implementation of a scope walker so the added methods
	will work beyond the global scope.  Not reliable yet, so its not used.

2004-05-05 Wednesday 22:26  geiseri

	Added the following functions to the part for embedders to enjoy:
	KJS::Value getValue( const TQString &valueName );
	KJS::Value callMethod(const TQString &methodName, KJS::List &args);
	void putValue( const TQString &valueName, const KJS::Value &value);

	Rich I have tests, but they require being compiled.  We need a C++ tests
	directory at this point i think to show off what we are up to.

2004-05-04 Tuesday 19:52  rich

	- Update class reference

2004-05-04 Tuesday 19:50  rich

	- Improved the argument handling of kjscmd so that it will automatically
	  invoke the console if there is no script to run. It will also call exec
	  implicitly in this situation, though not if there is a script to invoke
	  so the exec() call in the graphical scripts is still required.

	- Added a directory for a standard library of javascript utilities and put
	  the command line prompt script in it - other reusable scripts and objects
	  will follow. Scripts installed in this location will be found automatically
	  by the include(...) method.

	- Added an option to kjscmd to tell it to invoke the cmdprompt script from
	  the standard library.

	- Updated the man page to reflect these changes.

2004-05-03 Monday 21:21  rich

	- Added support for a few TDEHTMLPart method to the custom bindings.

	- Added a simple example of embedding the engine. This will be used
	  by the embedding tutorial i'm working on. The example is based on
	  the KDevelop template for a non-parts KDE app and embeds the
	  interpreter. It then offers an action to show the js console, and
	  a word count action that is implemented in js.

2004-04-30 Friday 20:53  rich

	- Improved binding wizard.

2004-04-30 Friday 20:27  rich

	- Extended the range of types supported by the XSL stylesheet to allow TQFile
	  and TQFrame to be wrapped. Added the generated wrappers to the build.

2004-04-30 Friday 19:36  rich

	- Integrated the constructor bindings into the binding wizard and added a hack
	  that only enables the first method we see with a given name, meaning that
	  only the first version of overloaded methods can be used. This change means
	  that the TQComboBox binding is now generated directly from the Qt header file
	  using the wizard.

2004-04-30 Friday 17:38  rich

	- Started rolling the code for instantiating bound objects into the wizard.
	  I accidentally deleted the stylesheet it uses to index the classes, so i'm
	  adding that to the repository now too so I don't have to write it a third
	  time.

2004-04-29 Thursday 21:11  rich

	- Improved the command line tool.

2004-04-29 Thursday 20:37  rich

	- Further steps towards a GUI for binding generation. The wizard pages are now
	  split up into functions and it uses an LED to provide feedback when it's
	  running doxygen. There's still a way to go, but this is slowly approaching
	  release quality.

2004-04-29 Thursday 20:34  rich

	- Update class reference

2004-04-29 Thursday 20:33  rich

	- Update class reference.

2004-04-29 Thursday 18:57  rich

	- More updates to the binding generation wizard.

	- Added support for the flush method to textstreams.

	- Added a script that provides an interactive command line prompt.

2004-04-23 Friday 22:19  rich

	Added the start of a wizard that will make creating bindings for a set of
	C++ classes a point-and-click process.

2004-04-23 Friday 18:47  geiseri

	Added event support for:
	TQEvent::TQTimer
	TQEvent::ContextMenu
	TQEvent::DragMove
	TQEvent::DragEnter
	TQEvent::Drop
	TQEvent::Enter
	TQEvent::Leave
	TQEvent::Clipboard
	TQEvent::DragLeave
	Based all events off the default handler so interited
	properties are preserved.

2004-04-23 Friday 15:57  geiseri

	move to TQProcess.

2004-04-23 Friday 15:20  rich

	Update to qt-only support

2004-04-23 Friday 10:57  geiseri

	added some of my things i want to see.

2004-04-22 Thursday 20:33  rich

	Update changelog.

	Allow C++ doc pages to link to each other in the docviewer.

2004-04-22 Thursday 20:27  rich

	Improvements to the docviewer.

2004-04-22 Thursday 20:17  geiseri

	remove printfs

2004-04-22 Thursday 20:01  geiseri

	since im trapped in the basement here, i figured id fix
	the appname patch rich commited.  Rich friends dont
	let friends use C string crap ;)

2004-04-22 Thursday 18:27  rich

	Changed the behaviour of kjscmd so that it uses the name of the script as
	the name of the instance it uses. This means that scripts can now have their
	own config files etc.

2004-04-22 Thursday 17:33  geiseri

	Added extractTQPalette
	Added extractTQStrList

2004-04-22 Thursday 16:57  rich

	Added support for Ian's new string munging functions to the XSL binding
	generator.

2004-04-22 Thursday 15:07  geiseri

	Normalized the size and color extraction.
	Added TQRect helper function.

2004-04-22 Thursday 15:03  geiseri

	Normalize extraction helper function so its easier to use with
	the bindings generator.

2004-04-22 Thursday 12:59  geiseri

	remove noise...

2004-04-22 Thursday 12:58  geiseri

	Found out javascripts month index starts at 0.
	Fixed validation test, and code
	Added ability to handle date, datetime, and time in slots
	Added ability to call slots that use datetime, date, and time.

2004-04-22 Thursday 10:01  geiseri

	added test for dealing with time in slots

2004-04-22 Thursday 09:17  geiseri

	Rich I really dont like this one bit.
	Added a few more slot signatures.
	Way more effort than its worth, we need to rethink how this all ties
	together.

2004-04-21 Wednesday 23:10  geiseri

	There is a moral here... untested code is buggy code.

2004-04-21 Wednesday 22:17  geiseri

	Added transparent mapping between Javascript dates and Qt's dates

2004-04-21 Wednesday 16:09  geiseri

	forgot to add the one i really wanted to.  Now we can map a string array to a TQVariant properly.

2004-04-21 Wednesday 15:48  geiseri

	Added the ability to convert from JS Arrays to stringlists.  Rich to use this
	code follow what i did in qcombobox_imp.cpp.  Its a oneliner and Hari says
	its the most maintainable way to do it...  Learned more about KJS than I ever
	did today.  Hari I owe you a beer, or 3, and john, you owe me your first born.

2004-04-19 Monday 11:53  geiseri

	fixed TQBoxLayouts.  might want to backport

2004-04-16 Friday 21:51  rich

	We can now build kjsembed without needing KDE! There is tidying up needed,
	but it builds ok.

2004-04-16 Friday 19:47  rich

	More work on making a qt only build possible. This build mode doesn't work
	yet, but the standard mode is unaffected by the changes.

	Tidied up the header file inclusion in various places which makes life simpler
	and should also speed up compilation.

2004-04-15 Thursday 20:19  rich

	More work towards a qt-only build

2004-04-15 Thursday 18:53  rich

	Began adding support for Qt-only builds.
	Explained to Ian's copyrights that the year is now 2004.

2004-04-13 Tuesday 12:08  geiseri

	Added DCOPClient::isApplicationRegistered(...)
	Added validation test for it.

2004-04-13 Tuesday 11:10  geiseri

	Test for clobbering return values of dcoprefs call.
	The fixed dcopref code... yay validation tests...

2004-04-12 Monday 17:48  geiseri

	DCOPRefs now work correctly as return values from javascript
	dcop interfaces.

2004-04-12 Monday 16:53  geiseri

	Added testcase for pixmaps.
	Fixed no object type returned bug.

	Dcop interfaces now work for more cases.

2004-04-12 Monday 16:28  geiseri

	test case to show off problems calling void functions in dcop interfaces.

2004-04-12 Monday 13:08  geiseri

	Fixed an issue with dcop interfaces where only the first
	argument was being read.

2004-04-12 Monday 10:11  geiseri

	Added ktempfile support.

2004-04-12 Monday 10:11  geiseri

	Added ability to invert pixels on the painter.

2004-04-12 Monday 10:10  geiseri

	More spacing and formatting fixes... soon my cvs will be in sync.

2004-04-12 Monday 10:09  geiseri

	Added support for the command shell(...).
	Added ksimple process ( a blocking shell process that returns the output)
	I dont like where this is going, but ideally in cvs we can work this out.
	The goal is to get a function that allows us to do the following:
		var response = shell( 'ps -aux' );
		prinln( response );
	So we can run simple shell commands and get a response back.
	Suggestions welcome.

2004-04-12 Monday 10:05  geiseri

	Formatting and spacing.

2004-04-12 Monday 10:03  geiseri

	Formatting and spacing cleanups.

2004-04-12 Monday 10:02  geiseri

	Added support for dcopstart (like the shell command line version).
	Added tests for dcopreferences.

2004-04-12 Monday 10:00  geiseri

	Added support for TQProcess as a bindings plugin.
	Exposed API identical to TQProcess.

2004-04-10 Saturday 20:40  rich

	Added support for the setSpacing method of TQHBox.

	Converted the docviewer example to use the TDEHTML streaming API and made it
	work properly.

2004-04-10 Saturday 17:24  rich

	Fix link to livedata example.

2004-04-09 Friday 21:26  rich

	Added support for streaming data to a KPart, and an example of doing so. This
	means you no longer need to have a temporary file to display stuff in tdehtml.

2004-04-09 Friday 20:22  rich

	Added an example of how to embed several parts in one scripts GUI.

2004-04-09 Friday 19:34  rich

	Added some methods that should allow us to have a unified interface to the
	proxy types in future. This change is the first step towards an understanding
	of inheritence. The first win of the change is that the code now understands
	that KXMLGUIClient's are not necessarily TQWidgets.

2004-04-09 Friday 17:52  rich

	Added proper support for TQComboBox. This binding was generated automagically
	using the xsl stuff in the tools dir, but I had to disable 4 methods to work
	around missing support for method overloading. There's also an example.

2004-04-09 Friday 16:39  rich

	Added support for loading read-write parts, and an example showing how it's
	done.

2004-04-09 Friday 15:32  rich

	- Made it so the man page gets installed.

	- Fixed some unused variable warnings.

2004-04-08 Thursday 09:52  geiseri

	Oh this is an annoying one.  For some reason I thought I could trust
	TQVariants to tell me what type they where.  It seems that in the
	instance of TQString vs TQCString this is not the case, so I am now
	doing this correctly and using the dcop functions type signature to
	get the correct types.  This fixes a few courious bugs I was chasing
	after in dcop.  I am trying to backport this fix now.

2004-04-07 Wednesday 19:38  rich

	Fix missing exec call found by David Joham.

2004-04-04 Sunday 19:33  rich

	Added a man page for kjscmd

2004-03-25 Thursday 19:48  geiseri

	Added the ability to expose child widgets as properties of a loaded UI file.
	This will allow one to import a UI file and then transparently address
	each of the UI elements via their name as given in the UI file.

2004-03-25 Thursday 19:16  geiseri

	this moved a few days ago.

2004-03-25 Thursday 19:12  rich

	Added an accessor to let the imp specify its factory.

2004-03-23 Tuesday 10:06  geiseri

	Moved the mimetype for javascripts to the tdelibs mimetypes.
	Removed useless feilds per davids advice.
	Matches the freedesktop.org format.


2004-03-22 Monday 20:29  geiseri

	hack to make javascripts open here with tdevelop.

2004-03-17 Wednesday 11:48  faure

	Lazy loading - don't slow down the loading of every TDEHTMLPart in Konqueror.
	OKayed by Rich.

2004-03-05 Friday 16:29  jowenn

	wrong warning

2004-03-04 Thursday 17:52  jowenn

	don't crash on slots having uint parameters. I could put it into a function, but I don't like my hack at all. I would appreciate, if somebody comes up with a better solution.


2004-02-29 Sunday 12:54  jowenn

	support for plugin based decorating of qobject derived return values from slots. If somebody has a problem with that, please let me know, I'll fork the code than, since i need it for kate scripting. the jsproxy behaves really bad for slots with default values and overloaded methods. From what I see they should get numbered, but they aren't


2004-02-29 Sunday 05:35  jowenn

	It's not nice, for each proxy implementation one TQGuardedPtr. :( I hope Qt's next generation smart pointer will be more lightweight. Why a qguardedptr?

	If you do the following in kjscmd it would crash without guardedptr
	var k=new TDEMainWindow();
	k.show();
	var k1=new TDEMainWindow();
	k1.show8);
	---> close k1 with the mouse
	k1.hide();   or k1.show();
	====> Crash

2004-02-16 Monday 02:42  geiseri

	Small code consolidation.  No real functional changes, just cleaner code.

2004-02-16 Monday 01:28  geiseri

	Added missing Brush type conversion.

2004-02-16 Monday 01:09  geiseri

	Added signatures for:
	    void slot_color( const TQColor &color );
	    void slot_point( const TQPoint &point );
	    void slot_rect( const TQRect &rec );
	    void slot_size( const TQSize &size );
	    void slot_pixmap( const TQPixmap &pix );
	    void slot_url( const KURL &url );
	    void slot_intint( int , int );
	    void slot_intbool( int , bool );
	    void slot_intintint( int , int , int );

	This should cover almost every signal that we can handle with
	native types in KJSEmbed.  Thanks Adam Treat from the C# stuff
	for the hints... now to streamline this junk.

2004-02-12 Thursday 14:51  geiseri

	Added an example of how RSSService can be interacted with
	using DCOPRefs and dcop signals.

2004-02-12 Thursday 14:51  geiseri

	Fixed an issue where dcoprefs would not be marshalled
	properly.

2004-02-11 Wednesday 19:02  rich

	Fixed a problem with non-mainwindow xmlgui clients not getting the
	actionCollection() method.

2004-02-11 Wednesday 17:19  rich

	Backport: Better fix for the crash when there is no actioncollection.

2004-02-11 Wednesday 17:15  rich

	Better fix for the crash when there is no actioncollection.

2004-02-11 Wednesday 17:12  rich

	Fix a crash when there is no actioncollection.

2004-02-11 Wednesday 14:33  staikos

	backport crash fix

2004-02-11 Wednesday 10:18  staikos

	don't krash

2004-02-09 Monday 13:41  rich

	Disable the KJS embed console plugin.

2004-02-01 Sunday 19:45  geiseri

	helps if you can actually create the little buggers too.

2004-02-01 Sunday 19:44  geiseri

	added support for dcoprefs.  the test assumes that your
	running the dcoprss service though.  to run the dcop test
	$rssservice
	$kjscmd dcop.js

2004-01-20 Tuesday 19:49  staikos

	No you really can't, Ian. :-)  This fixes KJSEmbed from crashing all over the
	place and I consider it a KJSEmbed showstopper pending review by Rich.  Without
	this patch I can't run space invaders.


2004-01-20 Tuesday 19:48  staikos

	For some reason [perhaps old admin/? don't think so...] at least one of my
	machines insists on generating moc for these even though it's commented out.

2004-01-15 Thursday 01:35  geiseri

	oh how i hate to merge xml files...

2004-01-14 Wednesday 14:51  zander

	Fix some bad layed-out button -- GUI problems

2004-01-11 Sunday 08:41  geiseri

	forgot to commit the image test.

2004-01-11 Sunday 02:08  geiseri

	use imagefx plugin.

2004-01-11 Sunday 02:08  geiseri

	reflect the changes to use include.

2004-01-11 Sunday 02:06  geiseri

	import was taken so include seems to work better for loading script libraries into kjsembed.

2004-01-11 Sunday 01:27  geiseri

	updat to ImageFX

2004-01-10 Saturday 21:35  rich

	- A first cut at specifying the public classes and generating their
	  documentation. Internal documentation (for people working on the code can be
	  created with doxygen Doxyfile-Internal).

2004-01-10 Saturday 20:38  rich

	- Added a hook for future bc virtuals.

2004-01-10 Saturday 20:12  rich

	- Fixed buffer overrun in argument handling.

	- Updated docs.

2004-01-10 Saturday 20:10  geiseri

	Use new image effects code.
	Works like a charm ;)

2004-01-10 Saturday 20:04  geiseri

	This is the ImageFX plugin.  It provides a wrapper arround KImageEffect and can be dynamicly
	loaded at runtime.

	To activate:
		var imgfx = new ImageFX();

	To use:
		var img = imgfx.blend(color, img, 0.25);

	All methods mirror their KImageEffects counterparts in function signatures.

2004-01-10 Saturday 20:00  geiseri

	Step 2.  Remove Image effects from the Image Bindings

2004-01-10 Saturday 19:48  rich

	- Added the unlisted demos to the index page.

2004-01-10 Saturday 19:45  geiseri

	Step 1 in conversion of ImageEffects to a plugin.

2004-01-10 Saturday 19:25  rich

	- Fixed support for TQChildEvent. It now has a type specific conversion
	  function rather than falling back to the generic one. Without this change,
	  it is pretty useless as you can't access anything or even distinguish
	  between insert and remove events.

	  The new code splits the childEvent() handler into two methods
	  childInsertEvent() and childRemoveEvent(). The code is disabled for now
	  behind the ENABLE_CHILDEVENTS define because there seem to be some problems
	  with reentrancy. This problem occurs if the callback is invoked because
	  kjsembed created an object.

	- Added my coverage checking scripts to the tools directory. These aren't
	  exactly the best, but they give an idea of which classes need adding.

	- Removed hard-coded list length from the event type <-> handler name map.

	- Commented out some unused args.

	- Updated TODO list.

2004-01-10 Saturday 14:33  rich

	- Add exception example

2004-01-10 Saturday 14:23  rich

	- Throw an exception when we fail to create a plugin too.

2004-01-10 Saturday 14:11  geiseri

	change the enums to work as they do, not as we hoped ;)

2004-01-10 Saturday 14:09  geiseri

	update the test

2004-01-10 Saturday 01:50  geiseri

	buttonmaker cleanup and moved to kjsuic

2004-01-10 Saturday 01:45  geiseri

	more changes to handle containers properly

2004-01-10 Saturday 00:28  geiseri

	some docs, and a minor cleanup to make it even cooler

2004-01-10 Saturday 00:19  geiseri

	This is a really simple class that simplifies dealing with UI files.
	It basicly wraps the loadUI function and autocreates an object for the
	main form, and presents the objects as properties.

2004-01-07 Wednesday 11:46  geiseri

	EnvelopeMaker example for KJSEmbed:
	This example will create postscript files for #10 Envelopes from a simple form.
	It will generate compliant postnet barcodes.  Im not sure if this works outside
	of the united states, but it works here.  It also is a nice example of how KJSEmbed
	can be used to build simple one off apps for your company.

2004-01-02 Friday 23:27  geiseri

	more exploration of how this works

2004-01-02 Friday 16:34  aseigo

	exec the application so something actually happens

2004-01-02 Friday 16:31  geiseri

	added some examples to test bumpmap code.

2004-01-02 Friday 16:31  geiseri

	fixed some minor issues with the bump map stuff

2004-01-02 Friday 16:30  geiseri

	Added abillity to set image mask correctly now.

2004-01-02 Friday 01:41  zrusin

	This is a huge present for geiseri. Fixing the biggest problem he had
	with his buttonmaker demo.

2004-01-01 Thursday 02:23  geiseri

	Removed the extra JSProxy argument from the convertToValue() function.
	All types should now be a ValueProxy, or a OpaqueProxy.

2003-12-31 Wednesday 11:54  geiseri

	use new TQPixmap code

2003-12-31 Wednesday 11:12  geiseri

	updated todo list

2003-12-31 Wednesday 11:11  geiseri

	missing include

2003-12-31 Wednesday 11:10  geiseri

	Moved Pen -> ValueProxy
	Moved Painter -> OpaqueProxy
	Moved Pixmap -> ValueProxy

	Fixed Pen and Pixmap handleing in the bindings
	Simplified Pixmap and Pen hadeling more

	Updated button maker to use new pillbox code

2003-12-30 Tuesday 14:23  geiseri

	move buttonmaker.js to new TQPainter stuff

2003-12-30 Tuesday 14:17  geiseri

	more for the pillbox test, we can paint directly on widgets now

2003-12-30 Tuesday 13:37  geiseri

	desktop file

2003-12-30 Tuesday 13:37  geiseri


	Added test for pillbox generation
	package script to make ButtonMaker installed as a real app.

2003-12-30 Tuesday 13:24  geiseri

	compile the correct file.

2003-12-30 Tuesday 11:41  geiseri

	compile the listview bindings...

2003-12-30 Tuesday 11:07  rich

	- Oops

2003-12-30 Tuesday 10:56  geiseri

	moved arg extraction code to slotutils
	converted TQPainter bindings to Opaque Proxy... it has issues still, but pending
	TQPixmaps conversion they cannot all be fixed yet.
	added arg extraction methods to simplify the code

2003-12-29 Monday 16:08  rich

	- Added a test program for the qlistview.

2003-12-29 Monday 16:08  rich

	- Added the binding for TQListViewItem and the latest xsl templates.

2003-12-28 Sunday 21:22  rich

	- Massive improvements to the binding generation tool. It can now create
	  usable code!!! To prove this, I've added a new binding to the builtins
	  directory for TQDir. This binding was generated directly from the qdir.h
	  header file using the scripts in the tools directory. There is a simple test
	  program in the test directory.

2003-12-28 Sunday 17:56  rich

	- More work on the bindings generator.

2003-12-28 Sunday 15:55  rich

	- More work towards automating the bindings process. It's getting there!

2003-12-28 Sunday 08:49  larkang

	CVS_SILENT ignore

2003-12-28 Sunday 08:43  larkang

	Some srcdir!=builddir fixes

	Ok'd by Richard Dale

2003-12-22 Monday 10:11  wildfox

	Fix invalid kjscmd sources, use /usr/bin/env kjscmd everywhere and chmod +x the right .js files

2003-12-22 Monday 07:57  cartman

	CVS_SILENT Add a GenericName. Use konsole icon as the app already uses it in title.

2003-12-21 Sunday 19:05  geiseri

	Changes to the plugins to autoregister... more later once i get a real network connection.

2003-12-20 Saturday 22:42  zrusin

	Fixing makefiles and a path. The makefile's in kjsembed need cleaning up, Coolo? :)

2003-12-20 Saturday 21:40  rich

	- Added a gray button template

2003-12-20 Saturday 21:08  rich

	- Added buttonmaker to the index page of the demos.

2003-12-20 Saturday 20:48  rich

	- Fix warning caused by attempting to overwrite the x and y properties of the
	  widget.

2003-12-20 Saturday 20:43  rich

	- Added support for command line args to the button maker. It will now read
	  the first argument and use that as the text. I also improved the defaults
	  including making it attempt to load the default button image on startup.

2003-12-20 Saturday 19:57  rich

	- Added keyboard shortcuts to buttonmaker

2003-12-18 Thursday 17:19  geiseri

	start of docs for this class, since an example will be in order.

2003-12-18 Thursday 17:15  geiseri

	Added support for adding bindings via KParts Plugins.
	I have tested ValueProxy and OpaqueProxy plugins and those work perfectly.
	TQObject based plugins are mostly working, but enums seem broken.

	The plugin interface is pretty thin right now, because I dont think we need
	a heck of alot to bootstrap the process of adding a binding.

	This is a start, I feel we need to ship 3.2 with this since we need a way to
	add bindings later without rebuilding kjsembed.  This also allows us to get
	arround messy instances where we may or may not want to have custom
	bindings to interfaces that are in KDE but may not make sense to be built
	into KJSEmbed.

	This api is subject to change as we kick it arround and clean it up, but so far
	it seems to work for my tests.

2003-12-18 Thursday 14:00  geiseri

	more clear idea of what happend when calling this slot.

2003-12-18 Thursday 13:58  geiseri

	Brush bindings to make the painter more fun.

2003-12-18 Thursday 02:23  geiseri

	maby even save the file too...

2003-12-18 Thursday 02:14  geiseri

	used the text box stuff to center the image.

2003-12-18 Thursday 02:02  geiseri

	a nice button for testing.

2003-12-18 Thursday 01:49  geiseri

	This might not be the right place for it, but we need a good way to get
	the bounding boxes of text drawn on the painter with the current font
	metrics.  Ideally we can move this later when we bind TQFontMetrics?

2003-12-17 Wednesday 23:37  geiseri

	Added a neat demo applet to show off KJSEmbed.  Its only a start, but a
	very good example of how KJSEmbed can do pretty powerful things in less
	than 100 Lines of code.

2003-12-17 Wednesday 18:50  geiseri

	painter fixes to change the font.

2003-12-17 Wednesday 18:12  geiseri

	group single arg members together

2003-12-17 Wednesday 18:10  geiseri

	Added ability to connect Qt signals to KJS Slots that have a single TQFont or TQColor.
	Not as cool as I would have liked, but I guess its okay.

2003-12-16 Tuesday 18:21  geiseri

	cleaned up the Image headers

2003-12-16 Tuesday 18:21  geiseri

	Moved DCOPClient code into a OpaqueProxy class.  This put it all
	into one place.  The big issue now is that until Pixmap is moved
	to a ValueProxy it will crash KJSEmbed when you pass pixmaps
	over DCOP.

2003-12-16 Tuesday 18:17  geiseri

	fixed test to reflect the real DCOP api

2003-12-16 Tuesday 14:11  rich

	- Fix imagegallery script for exceptions.

2003-12-16 Tuesday 14:01  rich

	- Fixed for new names of System.

2003-12-16 Tuesday 12:51  geiseri

	properties -> methods

2003-12-16 Tuesday 12:32  geiseri

	move properties -> methods

2003-12-16 Tuesday 12:29  geiseri

	make sure tables can stay in sync

2003-12-16 Tuesday 12:23  geiseri

	comment out unused functions for now

2003-12-16 Tuesday 12:05  rich

	- Fix image code.

2003-12-16 Tuesday 11:42  geiseri

	Start of move from opaque proxy to valueproxy
	Cleanup in Image to make it easier to follow.

2003-12-15 Monday 19:40  rich

	- Removed moc reference from ImageImp - it's not a TQObject anymore.

	- Fixed a crash when the factory is asked for an invalid part.

2003-12-15 Monday 18:35  rich

	- Improved the code of the image binding:

	  - Changed the name from Image to ImageImp as now that it doesn't use
	    TQObject, this class only handles the methods.

	  - Added support for the enums from KImageEffect. The output of the test
	    program should now be upside down.

	  - Added a second parameter to the save() method that specifies the format to
	    save in.

	- Made all the constants defined in enums read-only. This means scripts can no
	  longer corrupt the API (at least in this fashion).

2003-12-15 Monday 17:06  rich

	- Fixed the new image binding support so it works for the test program I've
	  added. I expect there is more work to be done to make this work nicely with
	  the property support, but you can load, transform and save files again.

2003-12-14 Sunday 12:36  geiseri

	Fixed the Image stuff so it will at least load.

	Came to the conclusion that there is all wrong, and we should revert
	back to the TQObject bindings.  The current implimentation makes
	no sense for how the Image binding is suppose to operate.

	Maby we really wanted a JSValueProxy?

	Rich please review this and let me know your thoughts.

2003-12-14 Sunday 11:02  geiseri

	Attempt at activating the Image bindings.

2003-12-14 Sunday 10:45  rich

	- const fix for gcc 3.3.

2003-12-14 Sunday 10:39  rich

	- Minor fixups.

2003-12-14 Sunday 10:23  rich

	- Add pen bindings

2003-12-14 Sunday 10:08  rich

	- Started adding the framework needed to allow custom value types to become
	  first class citizens.

	- Replaced the NewTQObject method of the factory with NewInstance which
	  supports the creation of instances of any type.

	- Added support for event types to the opaque proxy.

2003-12-12 Friday 23:58  geiseri

	removed old kdDebug statements and moved the ones that made
	sense to kdWarning.

2003-12-12 Friday 23:56  geiseri

	half of the move from TQObject binding to JSProxyImp
	rich this needs to be enabled, i was unsure of how to activate
	it.

	also am i correct in assuming that properties will no longer work for
	Image now that we are using a non TQObject binding?

2003-12-12 Friday 17:10  rich

	- Moved the registration of the global objects so it is handled inside the
	  JSBuiltins class rather than the part.

2003-12-12 Friday 17:03  rich

	- oops 2

2003-12-12 Friday 17:02  rich

	- oops

2003-12-12 Friday 16:49  geiseri

	example to show failure in enums on slots

2003-12-12 Friday 16:48  geiseri

	more fixes for enum values.

2003-12-12 Friday 15:18  rich

	- Replaced the TQObject wrapper for TQTextStream with a native binding
	  class. This reduces the overhead of this binding, and allows more
	  flexibility in the API we present to scripts.  The new binding provides the
	  same API to scripts as the old one, except that the current() and
	  setCurrent() methods have been removed as they are redundant.

	  This binding is the first one to be based on the JSOpaqueProxy class, but
	  this will in future be a common approach to wrapping non-TQObject classes.

	- Made a few methods of the factory that were previously protected have
	  private access. These methods are only useful internally, so there is no
	  reason to make them visible to users.

	- Renamed System.in -> System.stdin to avoid nameclash with the in operator
	  and made corresponding changes to the other stdio streams.

2003-12-10 Wednesday 21:05  rich

	- Major rewrite of the documentation generator script. The new version is a
	  lot cleaner and uses JS exceptions to handle problems rather than having
	  a hard-coded list of trouble-some classes. This change also makes a single
	  function responsible for the page template. The docs have also gained a
	  bunch of new index pages.

2003-12-09 Tuesday 20:42  geiseri

	example for message boxes.

2003-12-09 Tuesday 20:40  geiseri

	Added support for:
	alert(textMessage);
	confirm(textMessage);
	promp(textMessage, [inputDefault]);
	i18n(text);

	Added examples of the message boxes.

	i18n sorta works but may get removed if i cannot get it to work reliably.

2003-12-08 Monday 18:22  rich

	- Fix for gcc 2.95.

2003-12-08 Monday 17:53  rich

	- Don't use -no-undefined as this now requires libkjsembed.

2003-12-08 Monday 17:16  rich

	- Fix for --noexec -> --exec change.

2003-12-07 Sunday 21:00  geiseri

	Added a neat demo to show off event handling, and how generally awesome
	kjsembed is.

	Classic Space Invaders:
	Keys:
		<- go left
		-> go right
		<space> fire
	Mouse:
		click mouse to fire.

	Have fun.

2003-12-07 Sunday 20:59  geiseri

	Fixed some small confusion on the event mapper.

2003-12-07 Sunday 13:19  geiseri

	We can now grab windows.  Not sure how you get the winID yet though.

2003-12-06 Saturday 21:21  geiseri

	Reflect namechange from Dcop -> DCOPClient.

2003-12-06 Saturday 20:59  geiseri

	Added ability to connect dcop signals to kjs dcop slots.
	Added example to show this off.
	Removed a few compiler warnings.

2003-12-05 Friday 18:13  geiseri

	reflect a name change in the dcop client object.

2003-12-05 Friday 18:12  geiseri

	The ability to export a JS Method to a dcop interface now works.
	use DCOPInterface.publish("returnType signaure(ArgType)");
	as the format for publishing an interface.  The rest is transparent
	to the user.

2003-12-05 Friday 15:19  rich

	- Add a d pointer.

2003-12-04 Thursday 20:54  rich

	- Moved call to custombindings to a standalone method that encapsulates the
	  qobject handling.

	- Added warnings for unsupported methods that are defined in the
	  custombindings enum.

	- Fix warning in resources.cpp.

2003-12-04 Thursday 18:35  rich

	- Changed the inline version methods to non-inline. This means that the
	  concept behind these methods might actually work!

2003-12-04 Thursday 18:33  rich

	- Update js class reference.

2003-12-03 Wednesday 20:57  rich

	- Fixed a whole bunch of examples to call application.exec() themselves now
	  that kjscmd no longer does this automatically.

	- Moved call that adds custom object bindings into the factory.

	- Changed the default context Object for the parts execute methods to be the
	  global object of the interpreter, and changed the default global object to
	  be the one defined in libkjs.

	- Added a new optinal argument to the runFile() method of the part (and the
	  load() method it is bound to) that allows you to specify the context object
	  for the executed script.

	- Removed the virtual for the overloaded version of the part's execute()
	  method.

	- Made the part add its own binding to the interpreter instead of getting
	  kjscmd to do it, this means that the methods will be available when the code
	  is embedded in apps as well as standalone.

	- Simplified the API for publishing objects.

	  - Changed the publish() method to use the Object prototype.
	  - Simplified the addObject() method by using the factory properly.
	  - Renamed the publish() method to addObject() making the API
	    self-consistent (and made the code match).
	  - Fixed the design.h docs for the above.

	- Removed the createProxy() method that takes no context from the factory, and
	  replaced by making the context default to 0 on the overloaded
	  implementation. In many cases we were using because there was no sane
	  context to choose which indicates that the previous API was poor.

2003-12-03 Wednesday 17:47  rich

	- Oops. Finish removing self binding class.

2003-12-03 Wednesday 17:39  rich

	- Changed the default behaviour of kjscmd to /not/ call the exec() method of
	  the application. This method has available to scripts for some time now, and
	  the old behaviour forced scripts that called exec() themselves to include
	  convoluted work arounds.

	- Removed the mainwin option from kjscmd as scripts can now handle this
	  themselves.

	- Modified dumpCompletion() to use convertToValue().

	- Removed the SelfBinding class as it is now unused.

2003-11-30 Sunday 23:32  geiseri

	Merged CVS with local changes.

2003-11-30 Sunday 23:31  geiseri

	Added test that agrivates odd bug where "this" gets trashed.

2003-11-30 Sunday 23:31  geiseri

	Added TQStringList -> KJS Array support.
	Added TQPen -> Bindings::Pen support.

2003-11-30 Sunday 23:30  geiseri

	Added DCOP remoteFunctions, remoteInterfaces,
	remoteObjects, registeredApplication.

2003-11-28 Friday 20:30  rich

	- More work on using XSLT to generate the bindings. The code present at the
	  moment goes some way towards allowing us to move automatically from
	  doxygen's xml output mode to a set of JS bindings.

2003-11-28 Friday 04:27  coolo

	tdebindings relying on tdesdk? Next century perhaps

2003-11-27 Thursday 21:05  rich

	- Added some basic support for TQScrollView illustrated by the imagetweak
	  example, which will become more feature-full in future.

	- Added the very incomplete beginning of support for generating bindings from
	  doxygen's xml output.

2003-11-27 Thursday 19:43  rich

	- Moved the TODO list from the top-level directory to the docs directory.

2003-11-27 Thursday 19:34  rich

	- Moved the methods that wrap events into a standalone class
	  JSEventUtils. This class is not used directly, instead there is now an
	  additional createProxy() method in the JSFactory.

	  This change is a step towards adding some custom methods to enable us to
	  provide support for all the methods of the event classes, rather than just
	  the data members.

2003-11-22 Saturday 23:20  geiseri

	Moved the dcop call and send into the custom bindings.
	Rich im not sure if this is the correct location for these, but
	they currently work.

	Added a demo to show off the new dcop stuff, requires
	KWeatherService from tdetoys to be running, since i dont
	know how to start a service from KJSEmbed yet.

2003-11-22 Saturday 01:49  geiseri

	Added variable length args to K/TQListView.
	Added ability to handle Strings vs Pixmaps correctly.
	Added native method for grabWidget on TQWidget, this
	may get moved to Pixmap when i figure out how to handle
	a widget pointer.

2003-11-22 Saturday 00:54  geiseri

	Make the compiler a little quieter by commenting out unused args in functions.

2003-11-21 Friday 20:13  rich

	- Moved the native binding classes in builtins from the KJSEmbed::Bindings
	  namespace to the KJSEmbed::BuiltIns namespaces. Moved JSProxyImp from the
	  KJSEmbed::Bindings namespace to the KJSEmbed namespace.

	- Minor cleanups to SAX handling that make the code a bit easier to follow.

2003-11-21 Friday 17:22  rich

	- Update the demo to work properly with the changes made to the names of the
	  widgets in the console a few weeks ago.

2003-11-20 Thursday 20:04  rich

	- Renamed the 'global' object to 'Global' for consistency with web browsers.

	- Fixed some minor documentation error in the new builtin objects Ian added
	  (they're not TQObject wrappers!).

	- Added basic support for loading files via the SAX api, a callback based
	  mechanism for processing XML. The implementation is far from complete, but
	  it is enough to let you load some XML without hastle. You can use the api by
	  calling saxLoadFile( Object, String ) which takes as parameters, the object
	  implementing the callbacks and the name of the file to be loaded.

	  The callback methods that are currently working are:

	  Boolean startDocument()
	  Boolean endDocument()
	  Boolean startElement( namespaceURI, localName, qName )
	    - note that the attrs argument is missing.
	  Boolean endElement( namespaceURI, localName, qName )
	  Boolean characters( chars )

	  For a more detailed look at what's going on with all this, check out the
	  example in docs/examples/sax.

2003-11-20 Thursday 16:50  geiseri

	update the Todos so we know where we stand... still have to go back and check what is done.

2003-11-20 Thursday 01:13  geiseri

	Fixed the index to show  the actual functions.

2003-11-20 Thursday 01:04  geiseri

	update readme

2003-11-20 Thursday 01:03  geiseri

	merge with changes from head.

2003-11-20 Thursday 01:02  geiseri

	Added a completion object for the KDevelop KJSEmbed support.
	You can expose this via KJSEmbed's console via the raw() function
	that behaves just like dump() only it returns an array instead
	of a string.

2003-11-19 Wednesday 21:55  geiseri

	Updated docs to reflect the latest API. These where generated with build-docs.js.  Its starting to look like this might not be the best place to keep this stuff since we can now autogenerate it almost completely.  Maby this will be the last update.

2003-11-19 Wednesday 21:53  geiseri

	updated build-docs.js so that it now generates almost exactly what build-docs.sh does... only about 50x faster

2003-11-19 Wednesday 14:47  geiseri

	This is a sucky fix, but it works... this function really needs a clean up
	all these arrays screaming to be put out of their misery...

	any takers ;)

2003-11-19 Wednesday 00:58  geiseri

	Added support for TDEIconLoader and KStdDirs so we can find junk in KDE.
	Exposed :
		findResource, addResourceType, kde_default,
	    	addResourceDir, findResourceDir, saveLocation,
		makeDir, exists, realPath
		BarIcon, DesktopIcon, SmallIcon, MainBarIcon, UserIcon

2003-11-19 Wednesday 00:53  geiseri

	Updated docs for latest code in cvs.  Has new StdDirs and StdIcons stuff.
	Added SQL docs.

2003-11-18 Tuesday 19:02  rich

	- Fixed the image fun example. You can now pass pens around.

2003-11-18 Tuesday 18:16  rich

	- Minor change to debug output and an increase in the maximum number of args
	  to slots.

2003-11-17 Monday 19:20  rich

	- Added a mention of the scribble demo

2003-11-16 Sunday 02:23  geiseri

	yay we can now populate a TDEListView from an SQL query...  maby we need to put in a better demo app ;)

2003-11-16 Sunday 02:04  geiseri

	hrmmm it seems that implantTQVariant dosent work as i thought it should.  it seems once that is fixed things may
	work a bit better.

2003-11-16 Sunday 01:36  geiseri

	Fixed the TQPainter crash, it seems i had a booliean mistake
	Added TQVariant insertion support for DCOP... this still crashes, but gets further.

2003-11-14 Friday 22:48  rich

	- Fixed a problem in StdDialog where the bindings were returning strings that
	  told you 'this is null' rather than the real null value when the file
	  dialogs were cancelled. This error caused bad behaviour in the xmlgui demo.

	- Improved the type handling of the JSFactory class.

	  - The mapping between typenames and proxy types now supports all the proxy
	    types. This is essential if we are to support creation of non-TQObject
	    proxies properly.

	  - Removed the 'special case' code that handled identification of classes
	    supported by TQWidgetFactory.

	  - You can now remove support for particular classes by calling addType() and
	    specifying the proxy type TypeInvalid. I'm not sure how useful this is,
	    but we may as well allow it since it is trivial to implement.

	  - Split the code that adds the types into one method for each type of
	    object.

	  - Added some new JS methods to the Factory:

	    - isSupported(String)
	      Returns true iff the specified type is supported by the factory.
	    - types()
	      Returns an array naming all the types supported by the factory. This
	      list includes objects which can be wrapped but not created unlike the
	      constructors method.

	  - The methods now use TQString rather than TQCString to avoid needing lots of
	    charset conversions as these are an expensive operation.

	  - Added a new method addObjectTypes() that is responsible for telling the
	    factory about all the TQObject types it knows about that do not have any
	    sort of custom bindings. The list of currently unsupported types was
	    created by the scripts and data files in docs/examples/coverage/.

	- The readFile() method now throws an exception when the file cannot be
	  loaded.

2003-11-14 Friday 18:40  rich

	- Fixed the imageviewer example.

	  - It now loads the image specified on the command line rather than
	    hard-coding the name.

	  - Restructured the code so the water color operation is a function.

	  - Changed the code so it no longer uses return outside of a function (this
	    is invalid js and causes a warning from the interpreter). Instead, we use
	    throw which lets us send a message up the call stack to whatever invoked
	    us. This is a nice technique as it means things will work properly both
	    standalone, when we're called from another script and when we're called
	    by something that embeds the kjsembed part.

	- Added a new binding to the System class that lets you call exit. This is
	  needed because the kjscmd tool is currently calls exec() automatically. It's
	  a band-aid rather than a real fix, but it will give us time to decide on the
	  best solution to the problem.

	  - System.exit()       Exits with the status code 0
	  - System.exit(Number)	     Exits with the status code specified.

	- Added support for the TQLayout classes TQHBoxLayout and TQVBoxLayout. In
	  addition to the slots and properties, the following custom bindings are
	  available for box layouts:

	  - addWidget
	  - addSpacing
	  - addStretch
	  - addLayout

	  The creation code is current ifdef'd out as there are some problems, but the
	  methods are available to layouts created elsewhere.

2003-11-14 Friday 06:08  faure

	CVS_SILENT -I.. should be before all_includes

2003-11-11 Tuesday 19:27  geiseri

	yay more crashing test cases :)

2003-11-10 Monday 23:33  geiseri

	nice little test to crash dcop with :)

2003-11-10 Monday 23:12  geiseri

	fixes for dcop so it actually gets to the point of crashing, added a pen type

2003-11-10 Monday 23:11  geiseri

	Yay we can now officially do SQL queries... we really need a SQL cursor though to make it
	realy useful.

2003-11-10 Monday 23:10  geiseri

	Tried to get further, you can now set a pixmap, still cannot change it, no clue why...
	Added a pen type, it wont marshall properly, more type fun rich :)

	we crash when you do a drawText() it seems the qstring's dptr goes invalid... yeah thats cool

2003-11-10 Monday 23:09  geiseri

	Fixed a few things, we can now attach, and call commands, but now im getting the same issue we
	have in painter.  Things crash when reading a TQString that has been passed in... not sure why
	rich you have ideas?

2003-11-01 Saturday 11:34  rich

	- Attempt to fix problem with geiseri's SQL code.

2003-10-30 Thursday 20:20  rich

	- Moved the factory method implementations from JSBuiltInImp to
	  JSFactoryImp. The previous location was a mistake and made no sense at all.

	- Fixed the handling of KParts - the object was being registered incorrectly
	  which meant things were totally borked.

2003-10-30 Thursday 20:01  staniek

	retval fixed

2003-10-30 Thursday 19:29  rich

	- Split the JSValueProxy into two in order to solve the problem that TQObject
	  wrapper classes were broken by the increasing type-safety of the code.

	  - JSValueProxy now handles variant proxies and nothing else.
	  - JSOpaqueProxy takes over the handling of opaque pointer proxies.

	- Fixed the slot return code to fall back to the opaque type if the return
	  type is a pointer, but is not known by the factory as a TQObject.

	- convertToValue() now returns Undefined() for invalid TQVariant values and
	  unsupported types. This prevents scripts incorrectly reporting that the
	  method was successfull.

	- NOTE: These changes have fixed the problems that were occuring with TQObject
	  wrapper types.

2003-10-30 Thursday 17:57  rich

	- Made the remaining methods use the new naming code made possible by the
	  InternalFunctionImp code. This means that all the methods implemented in
	  native code now behave properly. The new code for adding the methods to
	  their parent objects is table driven which should make it easier to
	  maintain (or at least so I hope).

	  The methods that are wrappers for slots still need to be changed to use the
	  new code properly.

	- Removed the old ChangeLog stub (the real thing is in the docs directory).

	- Added d pointers to anything that didn't have one.

	- Removed the remaining createImp() methods because since the code was
	  refactored to remove the misuse of the part's imp they're a unnecessary
	  blight on the API.

	- Removed some TODO items that have been implemented.

2003-10-29 Wednesday 19:32  rich

	- Changed the base class of JSProxyImp from ObjectImp to the newly public
	  InternalFunctionImp (the internal here refers to the fact they are native
	  code rather than JS). This change fixes the problem that scripts could not
	  properly inspect the methods (for example instanceof was broken). The
	  InternalFunctionImp constructor requires an ExecState, so a few incidental
	  changes were required to accomodate this.

	  NOTE: This change requires the patch to KJS that I just committed.

	- Added some missing d pointers.

	- Improvements to doc comments.

2003-10-24 Friday 21:30  rich

	- Added a new class JSBuiltInImp that implements the bindings for the methods
	  defined by JSBuiltIn. Moved the code for these bindings out of the part imp
	  into the new class.

	- Minor cleanups to the initialisation of the builtins.

	- Improved class docs.

	- Made a couple more methods return exceptions instead of Null on
	  errors. These error types need to be centralised somewhere, perhaps in the
	  JSBuiltIn class.

2003-10-24 Friday 20:13  rich

	- Added some properties to the KPart that let scripts query the version of
	  KJSEmbed they are running in.

	- Improvements to the XMLActionClient class.

	  - Removed the XMLActionRunner member from the kpart because the default
	    runner is now an opaque class and you can do what you need via the
	    XMLActionClient.

	  - Fixed a potential crash in XMLActionClient (caused by the bad choice of
	    semantics when changing the runner).

	  - The actions are now deleted with the action client, this prevents a crash
	    when an action that was left behind is invoked.

	  - Added a copy constructor to XMLActionScript to ensure the semantics are
	    sane.

2003-10-24 Friday 19:01  rich

	- Added a new class JSFactoryImp which implements the constructors for
	  JSFactory. This is rather better than stuffing all this stuff into
	  KJSEmbedPartImp as we did before.

	- Renamed some of the public classes to add the js name prefix.
	  - factory.h/.cpp -> jsfactory.h/.cpp
	  - securitypolicy.h/.cpp -> jssecuritypolicy.h/.cpp

	- Moved JSProxyImp into its own file.

	- Moved the handling of JSBuiltIn from the factory to the part. This change
	  makes the logic make more sense, and removes a couple of methods that only
	  existed to work around the previous location in the factory.

2003-10-23 Thursday 19:26  rich

	- Started moving the builtin objects out of the factory and into a standalone
	  class JSBuiltIn. The part will ultimately be responsible for managing the
	  JSBuiltIn class which should simplify the factory (useful when we have
	  multiple factories).

	NOTE: Access to the TQObject-based wrapper objects is broken at the
	moment. This is a known issue and is being addressed, but as things are being
	restructured a bit fixing it will have to wait so I don't have to do it twice.

2003-10-18 Saturday 19:43  rich

	- Began adding support for non-TQObject ptr types.

	- The part no longer inherits XMLActionRunner, instead there's an internal
	  class that binds the two together. This makes the class hierarchy a lot
	  cleaner and reduces the linking between the xml action handling and kjsembed
	  which are really fairly distinct. Possibly this separation should go even
	  further and the part should avoid automatically creating an XMLActionClient
	  now that scripts can do this themselves.

	- Made some of the methods of the factory object take 'const TQString &' rather
	  than 'TQString'.

	- Reworked the handling of the JSFactory object. The factory is now a propery
	  of the kpart rather than being global. This means that applications can have
	  multiple active parts, each with their own factory. This change has required
	  changes throughout KJSEmbed:

	  - Changes to allow the static js objects to know which factory they should
	    be using.

	  - Changes to the proxies so they know which part they use rather than just
	    which interpreter. This has required changes all over the place, but
	    better now than later.

2003-10-18 Saturday 16:16  geiseri

	imageviewer with nifty watercolor effect now.

2003-10-18 Saturday 15:32  geiseri

	More updates to the SQL support.  Changed the name to make it more clear
	that it was SQL.  Still cannot get SqlDatabase.exec() to return a real
	query, even thought the database says its all good.

2003-10-17 Friday 21:52  rich

	- Removed the createSubProxy() method of JSObjectProxy and made the JSFactory
	  take over this operation completely.

	- Made a create() method in the factory that returns a pre-wrapped
	  object. This method also throws a JS exception if creation fails instead of
	  needing the client to check the return value.

	- Removed support for the create() method that early scripts used to
	  instantiate things, now you must always use new to create objects. This
	  method was only ever introduced because I hadn't figured out how to define
	  proper constructors, so no one should really miss it.

2003-10-17 Friday 17:50  rich

	- Moved the kjsconsole plugin into its own directory. This has been requested
	  by people working on a couple of apps that would like to use the code. This
	  is a good idea anyway because it makes the separation between the core of
	  kjsembed and the clients clearer.

	- Fixed a few unused parameter warnings.

2003-10-17 Friday 17:26  rich

	- Moved builtins to a new directory. This isn't really needed yet, by doing it
	  now we avoid lots of pain later.

	- Improved support for TQTimer.

	  - You now have access to the start(), stop() and isActive() methods.
	  - Added an example that uses the new timer support.

2003-10-17 Friday 10:57  rich

	- Removed kpublished as it is unnecessary and seems to be unmaintained.

2003-10-11 Saturday 20:05  rich

	- Extended the code for dumping slots so the output includes the return type.

	- Added a debug area (80001) to the list in tdecore and changed all the debug
	  messages to use it.

	- Added the ability to tell the factory that particular class names are
	  qobjects and made the creation code call it when it creates an object that
	  is an instance of an unsupported class. Note that this code does not
	  understand namespaces, so you need to explicitly qualify everything for it
	  to work properly.

	  - Changed the addConstructors method of the factory up so that it uses the
	    fully qualified names for the bindings classes.

	  - Changed the jscript() method of the console widget to use the qualified
	    name for the part.

2003-10-11 Saturday 16:26  rich

	- Fixed code for implanting Qt types in unsupported signatures. The code was
	  ignoring the index of the parameter.

	- Improved slot parameter support.

	  - Abort on the first unsuppored type so we don't waste time if we're already
	    stuffed.

	  - If the parameter type is a pointer and the passed value is a proxy we now
	    pass the value to the slot. Hopefully this will work for both
	    JSObjectProxy values and for opaque values.

	  - If the parameter type is supported by TQVariant and the passed value is a
	    proxy we should now support that too.

2003-10-11 Saturday 15:32  rich

	- Began to add some flesh to the JSProxy class.

	  - Added a bunch of methods to handle the type conversions and tests
	    cleanly. Used these to centralise a whole bunch of down-casts making the
	    rest of the code a lot more readable.

	- Added an implant method for proxy classes. This method will make it possible
	  to pass TQObjects, opaque values and unsupported variant types as parameters
	  to slots.

2003-10-09 Thursday 21:14  rich

	- Made the arguments passed around during slot invocation a lot simpler. We
	  now pass around the slotimpl itself rather than all of the members it holds.

2003-10-09 Thursday 20:41  rich

	- Did some tidying up of the slot handling code.

	- Removed unused JSObjectProxyImp constructor.

	- Lots of work on handling slots that return pointers. Slots that return types
	  supported by TQWidgetFactory now work, adding support for the other TQObject
	  types will be pretty simple at this point. The code really needs to be a lot
	  more generic - rather than asking the factory if the object is a TQObject, it
	  should be asking the factory if there is a wrapper available for the class.

	  - Did most of the grunt work required to handle slot pointer return types
	    properly. At the time we bind a slot we extract the return type from the
	    metaobject, the classname we obtain is stored in the slot binding
	    implementation.

	  - Extended the slot invocation stuff to use the addition information about
	    the return type we've now stored.

2003-10-08 Wednesday 20:37  rich

	- Added some notes to the TODO file that show how we can extract the return
	  type of a slot that returns an object from the metainfo.

	- Tidied up and documented the console widget class.

	  - Removed the clear button Ian added. I really don't think this fits very
	    well as it removes the correspondence with a normal console. I've added an
	    access to for the hbox that arranges the entry fields to make it possible
	    for client class to do this sort of thing themselves if they feel it is
	    needed. This accessor also lets you use the console widget in a
	    non-interactive fashion as you can hide the entire entry section.

	  - Initialised proc to 0 and made the child handling slots back into slots so
	    that the process invocation code will work properly.

	  - Changed the names of the child objects to be lower-case for consistency
	    with everything else.

	  - Moved the popup title out of the d pointer object since we're not
	    retaining b/c for kjsembed this release.

	  - Set both large and small WM icons.

	  - Updated result handling code to use the facilities the part provides now.

2003-10-02 Thursday 02:11  geiseri

	added the abilty to clear the cmd line with a button... not sure if i like this operation yet.... maby clear
	should clear the log, and when you execute a command the line should get cleared. going to play with this for a
	while

2003-10-02 Thursday 02:01  geiseri

	Added support for the javascript mime type.
	Added desktop file so clicking on a js script will execute it... NOTE: im not happy about this but i cannot
	figure out how to get it to open in a text editor when its chmod -x and kjscmd when its +x... ideall this will
	be fixed in the next few days or ill disable the kjscmd desktop file.

2003-09-28 Sunday 13:30  geiseri

	start of port ob build-docs.js to kjs

2003-09-27 Saturday 20:37  geiseri

	updated the docs to reflect the new members

2003-09-19 Friday 19:58  rich

	- Improved the System class API:

	  - Added new method bool writeFile( filename, text ).
	  - Renamed System.stdin etc. to System.in, System.out and System.err.
	  - Fixed examples for the new names.

	- Started adding support for classes. The first stage here has been to add
	  (somewhat messy) support for associating enum values with the correct
	  type. This means that rather than having to reference these values via the
	  class instance, you can say things like:

	  var f = new TQFrame();
	  f.frameShape = TQFrame.WinPanel | TQFrame.Sunken;

	  It is important to note that with the current code, the enum values are not
	  available until after the first instance of the specified type has been
	  created.

	- Moved EventType back into the cpp class as it is only used internally.

2003-09-18 Thursday 19:35  rich

	- Added a new class JSProxy to be a baseclass for JSValueProxy and
	  JSObjectProxy.

	- Moved the event handler mapping code into a standalone class JSEventMapper
	  which will be its final location. Added various methods etc. to make this
	  work with everything else.

	- Added a new example that creates a complete KDE mainwindow with all the
	  standard menus and toolbar using the KStdAction bindings and XMLGUI. This
	  example also shows how you can wire a TDEAction to a JS function using the
	  slot support by adding proper support for the file open action.

2003-09-18 Thursday 18:36  mueller

	unbreak compilation. I wonder why I waste time on fixing it if the
	fixes get reverted anyway.

2003-09-18 Thursday 16:58  rich

	- Fix geiseri's code from last night.

	- Fix Makefile.am to work properly.

2003-09-18 Thursday 15:48  rich

	- Minor updates

2003-09-17 Wednesday 22:13  geiseri

	workarround for Qt bug where moc cannot handle ',' any more...

2003-09-17 Wednesday 21:38  geiseri

	crackrock EVERYWHERE!  im going to bed...

2003-09-17 Wednesday 21:33  geiseri

	god dammnit, i obviously cannot code anymore this evening...

2003-09-17 Wednesday 21:09  geiseri

	Added start of bindings for a TDEConfig object.
	this is mostly untested, but it compiles so we can start to debug it.

2003-09-17 Wednesday 01:43  geiseri

	im sure rich really dosent want credit for this sucker ;)

2003-09-17 Wednesday 01:41  geiseri

	Added SQL Database and Query bindings.
	Known issue is with Database::exec();  This returns a Qt SQL Query.  I added what I thought was the
	correct constructor to Query() so that we could handle it from JS, but it keeps responding that the query
	is a null type.  Rich what is the correct way to handle these types?  Once this is resolved we can start
	on the more advanced SQL features.

2003-09-17 Wednesday 01:37  geiseri

	Added demo of SQL features.  We can now connect to the database, but there are some issues with the
	query.

2003-09-16 Tuesday 01:26  geiseri

	Added support for TQMovie so we can spice up our boring GUIs...

2003-09-15 Monday 22:52  geiseri

	fixed Painter::drawText to really draw text
	added:
	    void drawArc( ... );
	    void drawPie( ... );
	    void drawPixmap ( ... );
	    void drawImage ( ... );
	    void drawTiledPixmap ( ... );

	    void scale ( ... );
	    void shear ( ... );
	    void rotate ( ... );
	    void translate ( ... );
	to Painter

2003-09-15 Monday 20:18  geiseri

	changed image viewer to apply some effects.

2003-09-15 Monday 20:17  geiseri

	Moved image_imp from a TQImage * to a TQImage value.
	Added image effect members to pixmap_imp
	Added image effect members to image_imp

	These need more testing but just a simple test seems to pass and look good.


2003-09-15 Monday 19:07  rich

	- Added 3 new methods to the KPart that provide access to the defined
	  constructors. These replace the dumpConstructors() function in
	  jsbindings.h which has been now been removed.

	    TQStringList constructorNames() const;
	    KJS::Value constructors() const;
	    KJS::List constructorList() const;

	- Moved some methods of the part so they are no longer slots since it
	  seems that returning non-ptr, non-variant types like KJS::Object
	  through a slot isn't going to work due to limitations in moc. The
	  same limitations apply to properties unfortunately.

	- Added more debug info.

2003-09-15 Monday 17:04  geiseri

	Added support for the following events:
		TQKeyEvent, TQWheelEvent, TQFocusEvent, TQPaintEvent, TQMoveEvent
		TQResizeEvent, TQCloseEvent, TQShowEvent, TQHideEvent, and TQIMEvent.

	These need to be tested and it should be noted funcitons that return void, are not currently implemented.


2003-09-14 Sunday 18:18  rich

	- The events are now defined using an array, this makes it much easier
	  to maintain and to add support for new event handlers.

	- Added a binding to TQApplication::exec(). If this works ok, I think I
	  should probably make no-exec mode the default and leave the decision
	  entirely up to the script. This would mean I'd need to add a -exec
	  option to allow you to use the console widget with non-graphical
	  scripts.

	- Various clean ups.

	- Added support for the TQObject className() method to the object
	  proxy, and an extra method superClassName() that queries the
	  metaobject.

	- Note that I'm still working on the 'no default value' problem.

2003-09-11 Thursday 18:30  rich

	- Rename the new factory to avoid the reserved word.

2003-09-11 Thursday 05:45  rich

	- Doh, forgot the code

2003-09-10 Wednesday 20:20  rich

	- Added support for some more of the TQMouseEvent class.
	   state()
	   stateAfter()
	   globalX()
	   globalY()

	- Fixed some of the TDEMainWindow method bindings which were totally
	  broken. These bugs explain why a number of things I was trying to
	  write never worked.

	- Added a binding to KStdAction. This lets you create instances of any
	  of the standard KDE actions from scripts. For example, you can write
	  the following:

	  var act = StdAction.quit( recv, slot, parent, name );

	  Note that at the moment the receiver and slot cannot be a JS object
	  and method, they must be a slot defined in C++.

	- Added an example to docs/examples/actions/


2003-09-06 Saturday 17:36  rich

	- Added getParentNode() to the DOM api.

	- Added implementation of KJS::Identifer::qstring().

	- Added the JSObjectEventProxy class. This class forwards Qt events to
	  javascript handler methods. This means you can now write scripts
	  that handle events!

	  The basic method it uses is to install an event filter for the
	  target of the JSObjectProxy it is created for and test if any events
	  the target receives should be forwarded using a bit array. If the
	  event needs forwarding it looks up the name of the handler and calls
	  it, if not then processing occurs as normal.

	  The creation of the event proxy is handled by the object proxy which
	  overrides the set property handling in ObjectImp to detect when a
	  script assigns to a method that is an eventhandler. The event proxy
	  is created the first time this happens (and is deleted when the last
	  handler is removed).

	  In order to implement the scheme described, there needs to be a
	  both a mapping between handler names and TQEvent::Type, and a mapping
	  between the type and the handler. The first is used to determine
	  if assigning to a property should cause any event types to be
	  forwarded (and which types they are), the second lets the event
	  filter know which js method it should call.

	  In addition to supporting the standard event handlers needed to
	  write Qt/KDE wrappers, this code is intended to support weird
	  compatibility stuff like kaxul. :-) This requirement means we need
	  to allow for the possibility of custom event types, events mapping
	  to custom handler names, and also custom signatures in event
	  handlers. The same difficulties occur when support for custom
	  TQEvents is considered. This side of things is very much a work in
	  progress.

	  At the moment both mappings are stored in the factory object, but
	  I'm not convinced this should be their real location. If anyone has
	  any thoughts on this, then please let me know. The other big
	  question is the time at which names should be resolved to
	  (hopefully) callable objects.


2003-09-03 Wednesday 17:02  rich

	- Added bindings to KColorDialog and KPropertiesDialog to StdDialog.

	- Moved StdDialog binding code from the factory to the class itself.

	- Added support for creating TQScrollView and TQCanvasView widgets.

	- Added support for TDEMainWindow::createGUI().


2003-08-27 Wednesday 18:37  rich

	- Fixed tree example (I added a sh-style comment) and added a better
	  demo ui file.

2003-08-27 Wednesday 18:24  rich

	- Added binding to isWidgetType().

	- Added an example that generates a graphical tree of the TQWidget
	  hierarchy.

	- Fixed const warning in convertToValue(). Various other irritating
	  const fixes.

	- Added support for enums! This means that you can now use enums that
	  have been declared using Q_ENUM in scripts. The enums are published
	  as properties of the object itself for now, rather than the class
	  (this will be fixed). This means that for now you do things like
	  this:

	     f = new TQFrame();
	     f.frameShape = f.Panel;

	- Added a new demo 'frame' that illustrates TQFrame and enum support.


2003-08-27 Wednesday 14:30  geiseri

	made the slot invoke a little smarter.  we now have both the old and new methods to keep everyone happy.

2003-08-26 Tuesday 20:10  rich

	- Moved code for adding custom functions to the corresponding imp
	  class.

	- Added context information to convertToValue() so that we can ensure
	  the security policy is followed. Without this change, proxies that
	  are created by this method will revert to the default policy. This
	  fixes the security hole I referred to earlier.

	- Added a binding to JSValueProxy that returns the name of the
	  contained type.

	- Added a new native binding StdDialog that will provide an easy way
	  to access the common KDE dialogs. This class is far from complete at
	  the moment.

	  getOpenURL(...)
	  getSaveURL(...)
	  getExistingDirectory(...)
	  getOpenFileName(...)
	  getExistingURL(...)
	  getImageOpenURL(...)
	  getSaveFileName(...)


2003-08-21 Thursday 19:45  rich

	- Added a factory method for proxies that are explicitly published.

	- Renamed some ExecState params called 'state' to 'exec' for
	  consistency and reordered some method args for the same reason.

	- Moved the JS method load() out of the factory object and into the
	  global namespace.

	- Added an example showing how to write scripts that span multiple
	  source files.


2003-08-21 Thursday 18:36  rich

	- Modified the JSFactory class so that it is no longer used via static
	  method calls. These changes have been made so that host applications
	  can define custom factories. There are more changes to come in this
	  area, so please don't use on it yet.

	- Moved creation of sub-proxies to the factory.

	- Something seems to have broken the listview example. I'm not sure if
	  it is one of my changes, or if it's the generic slot support geiseri
	  added.


2003-08-18 Monday 23:48  geiseri

	Variable length slots now work for the currently known types.  Things seem
	to pass the old tests, and some new dcop tests now pass.  TQVariants still
	need to be handled.  I leave for my flight in 17hours so im not optimistic
	ill get in one more commit.  Rich please dont try to clean this up yet, as
	ill probibly work on it before i get net access on thursday.


2003-08-18 Monday 23:46  geiseri

	Make this work with Qt 3.2... not sure if this has bad side effects yet,
	please test.


2003-08-18 Monday 15:40  rich


	  drawRoundRect().

	- Added a new example that illustrates support for TDEListView.

	- JSValueProxy instances that contain a TQVariant can now be converted
	  back to TQVariant.

	- Moved JSValueProxy out of the Bindings namespace.

	- Added a new example that tests the support for opaque values.

	- Did a bit of work on the Painter binding, still doesn't work
	  though. :-(

	- Added support for opening files (ro/rw) a TextStream is returned.
	  (currently commented out as it is flawed).


2003-08-18 Monday 13:39  geiseri

	it helps rich to debug it if he has the same code.

2003-08-17 Sunday 11:46  rich

	- Added a new class JSValueProxy which provides an opaque binding to
	  either a TQVariant or a void pointer.

	- Extended the property handling code to automatically generate opaque
	  bindings for unknown types.

	- Added a new method Factory.widgets() that returns a list of the
	  widgets supported by TQWidgetFactory.

	- Added support for pointer slot return values.


2003-08-16 Saturday 18:33  rich

	- Moved the implementations of the custom methods (ie. those that are
	  not slots) to their own class.

	- Documentation

	- Made the built-in objects use the default Object prototype for their
	  KJS::Object.


2003-08-16 Saturday 17:16  rich

	- Added some more doc comments.

	- Added support for slot signatures needed by NetAccess:

	  slot(const KURL&,const TQString&)
	  slot(const TQString&,const KURL&)


2003-08-16 Saturday 16:48  rich

	- Minor cleanups of the kpublished code.

	- Cleaned up the factory's create methods. There is now one for each
	  type of object created.

	- Fixed NetAccess (I was too enthusiastic in converting stuff to
	  KURL).


2003-08-16 Saturday 15:52  rich

	- Modify TDEIO::NetAccess binding to use KURLs now we support the 2
	  argument variant.


2003-08-16 Saturday 15:42  rich

	- Added support for slots that take 2 kurls.


2003-08-16 Saturday 15:01  jowenn

	A modified dcopidl* toolchain for restricting which slots should be published to kjsembed. It's quite generic from the idea, so it should be usable with any other script language too. It's a first try/begin though, so it doesn't do much yet except for the test also committed  I hope to get signal restrictions to work too and fix some compatibility problems with Qt's moc

2003-08-16 Saturday 14:41  rich

	- Added support for a 4 argument for of createROPart() to allow you to
	  specify custom constraints for the TDETrader query.


2003-08-16 Saturday 13:48  zrusin

	Fix implicit casts.

2003-08-15 Friday 19:53  rich

	Update changelog and docs

2003-08-15 Friday 19:46  rich

	- Ensure we add the args array to the application object even when it
	  is empty.

	- Improved the readonlypart demo to be proper browser (ie. make links
	  work).

	- Improved factory creation code.


2003-08-15 Friday 18:45  rich

	- Added support for creating read-only KParts.

	- Added an example that displays the KDE homepage in a TDEHTMLPart. This
	  example also shows the use of the main window bindings.


2003-08-15 Friday 18:08  zrusin

	Use new instead of app.create and a few path fixes.

2003-08-15 Friday 17:55  zrusin

	Make the new call work with NetAccess

2003-08-15 Friday 17:49  rich

	- Added compatibility with KDE 3.1 so I can actually use this stuff!

	- Minor cleanups to the examples.


2003-08-15 Friday 09:13  zrusin

	Don't crash when creating widgets/dialogs from ui files (and use more
	sensible way of detecting kjscmd)

2003-08-15 Friday 04:59  zrusin

	Adding TDEIO::NetAccess binding. So now from within scripts you can do:
	var net = application.create( 'NetAccess', 'net' );
	net.download( 'http://www.kde.org/media/images/kde_logo.jpg', '~/logo.jpg' );
	To download anything you want. It be cool if one could disable the progress
	dialog for netaccess.

2003-08-14 Thursday 22:00  rich

	- Added some more slot signatures:

	  - slot(const TQString &,uint)
	  - slot(const TQString &, bool)
	  - slot(int,const TQColor &)
	  - slot(int,int,int,int,int)
	  - slot(const TQPixmap&)
	  - slot(const TQRect&,bool)
	  - slot(const TQString&,bool)
	  - slot(const TQString&,bool,bool)
	  - slot(const TQString&,int,int)
	  - slot(int,const TQColor&,bool)
	  - slot(int,const TQColor&)
	  - slot(int,int,float,float)
	  - slot(const TQString&,bool,bool,bool)

	- Added a utility method for getting the TQWidget in a proxy.

	- Added support for TQPixmap properties.

	- Added imageviewer example.


2003-08-14 Thursday 19:07  zrusin

	Yeah, real funny

2003-08-14 Thursday 19:02  zrusin

	Correct makefile for a static lib.

2003-08-14 Thursday 18:02  rich

	- It helps if we actually make the TQString,TQString slots available to
	  the JS interpreter...

2003-08-14 Thursday 17:57  rich

	- Added a JS prefix to a couple of classes.

	- Added support for slots with 2 string arguments


2003-08-14 Thursday 14:39  rich

	- Add support for the full loadui command including the connector.

2003-08-14 Thursday 14:16  rich

	- Make kawil happy by fixing the parent argument to loadui.

2003-08-13 Wednesday 15:58  zrusin

	Adding bindings as a subdir dir. Fixing the non-working implicit cast of
	TQString to const char* to make it compile.
	Rich are sure the bindings lib should be installable shared lib, and not
	a static, non-installable one?


2003-08-12 Tuesday 18:06  rich

	Oops

2003-08-12 Tuesday 18:03  rich

	Moved to bindings/

2003-08-12 Tuesday 17:57  rich

	- Moved the TQObject classes that only exist to provide bindings into a
	  new directory. This will hold all the classes that exist only to
	  provide a binding.

2003-08-12 Tuesday 17:02  rich

	Grr, i fucked this up again

2003-08-12 Tuesday 16:29  rich

	- Added calculator example

2003-08-12 Tuesday 16:24  rich

	- Factory can now create TDEMainWindow.

	- Added binding methods to TDEMainWindow.
	  - setCentralWidget()
	  - actionCollection()

	- SlotUtils is no longer used by inheritence, woo hoo!
	  This means that apps will be able to extend it soon.


2003-08-08 Friday 01:04  staikos

	This thing really hampers Konqueror startup time, and it provides nothing of
	value to konqueror itself.  Any solution, rich?  Do we really need it?


2003-07-30 Wednesday 18:52  rich


	- Added support for calling slots with signatures uint, long and ulong
	  as methods.

	- Added support for connecting signals with unsupported signatures to
	  JS methods. Note that currently *none* of the arguments will be
	  passed to the script in this situation.

	- Minor fixes to docs.

	- Added an example 'connect' that shows how the most common types of
	  signal can be connected to JS methods.


2003-07-29 Tuesday 17:34  rich

	Try make things work for jowenn

2003-07-28 Monday 08:39  mueller

	unbreak compilation (gcc 3.4+)

2003-07-28 Monday 08:38  mueller

	I don't know how this code is ever supposed to compile, but at least it
	will produce the .moc files correctly.

2003-07-27 Sunday 20:25  rich

	- Added d pointer to SlotUtils. Constructor and destructor no longer
	  inline, this should make compatibility easier.

	- More doc improvements.

	- Removed the overloaded openURL() method that takes a string as we
	  support KURL parameters now.

	- Started implementing support for connecting signals to Javascript
	  functions. The code for this is mostly in the SlotProxy class.

	- Modified the docviewer example to make use of the JS slot
	  support. This example now works pretty much the way it is intended
	  too!


2003-07-27 Sunday 18:00  mueller

	unbreak compilation (gcc 3.4+)

2003-07-27 Sunday 18:00  mueller

	libkjs is not in my tdebindings

2003-07-27 Sunday 16:19  rich

	- Fixed Makefile.am problem.

2003-07-26 Saturday 22:32  rich

	- Removed the default value of 0 for the wparent of one of the
	  KJSEmbedPart constructors. This means that the defaults no longer
	  trigger the crash-on-exit bug.

	- Made createInterpreter() protected because calling it twice calls a
	  memory leak and there's no need for apps to use it anyway.

	- Added an accessor for the completion object of the last script.

	- Renamed executeScript() to runFile(), and loadScript() to loadFile()
	  to make the semantics clearer.

	- Replaces some overloaded methods with default arguments.

	- Fixed the 3 argument version of connect to match Qt, and tidied up
	  the way connect is processed. Matching changes for disconnect.

	- Added support for the slot signatures:

	  - int,int,int,int,bool.
	  - TQRect, bool


2003-07-26 Saturday 17:51  rich

	- Made the makefile put the changelog in the docs dir

2003-07-26 Saturday 17:44  rich

	- Moved low-level slot handling into a standalone class SlotUtils that
	  JSObjectProxyImp inherits. This makes the code a lot easier to work
	  on as the JS glue and the Qt glue are no longer stuck together.


2003-07-26 Saturday 17:09  rich

	- Documentation updates

2003-07-26 Saturday 16:49  rich

	- Added links to TQSA and a tutorial on inheritence in JS.

2003-07-26 Saturday 16:35  rich

	- Added some information about planned changes.

2003-07-19 Saturday 16:47  rich

	- Removed kspy dependency

2003-07-18 Friday 20:39  rich

	- Added constructors for the Painter object.

	- Added a new binding Pixmap that provides an interface to TQPixmap.

	- Removed duplication of the BindingObject construction code. The
	  custom binding objects now use the same code as the classes defined
	  by TQWidgetFactory.

	- Removed test signals and slots from the kpart.

	- Added support for widget classes to the script that generates the JS
	  API reference. This means the reference manual now includes every Qt
	  and KDE object available!

	- Started writing a JS documentation viewer.

	- Started adding support for custom methods:

	  - jsobjectproxy.cpp	     Added insertItem method for TQListBox
	  - jsobjectproxy_imp.cpp
	  - jsobjectproxy_imp.h

	- Cleanups

	  - kjsembedpart.h		Tidy the code up and document
	  - kjsembedpart_imp.cpp	Added a new method constructors that
	  - returns an
			array of constructors.
	  - kjsembedpart_imp.h
	  - pixmap_imp.cpp		Added pixmap property
	  - pixmap_imp.h

	- Improved docs

	  - docs/index.html		Added link to mozilla js language page

	- Improved access to bindings

	  - factory.cpp		Added constructors()
	  - jsobjectproxy.h	      Added addBindingCustom()

	- Converted state -> exec for some more functions.

	- Added some custom bindings for useful widgets. This code needs
	  cleaning up more before it is ready for prime time. The methods
	  added are:

	  TQListBox::addItem()
	  TDEListView::addColumn()
	  TQListView::addColumn()
	  TDEListView::insertItem()
	  TQListView::insertItem()

	- Started writing a new example that provides a documentation browser
	  for KJSEmbed.


2003-07-11 Friday 21:43  rich

	- Added constructors for the Painter object.

	- Added a new binding Pixmap that provides an interface to TQPixmap.

	- Removed duplication of the BindingObject construction code. The
	  custom binding objects now use the same code as the classes defined
	  by TQWidgetFactory.

	- Removed test signals and slots from the kpart.

	- Added support for widget classes to the script that generates the JS
	  API reference. This means the reference manual now includes every Qt
	  and KDE object available!


2003-07-10 Thursday 20:35  rich

	- Added a document that describes the types used to pass data between
	  Qt and scripts.

	- Improved the documentation front page and stylesheet.


2003-07-10 Thursday 17:56  rich

	- Fixed links to examples.


	- Minor doc changes.


2003-07-05 Saturday 20:43  rich

	- Added support for getting the values of rect, size and point
	  properties. The values are returned as arrays, the types are as
	  follows: TQRect -> [x,y,w,h], TQSize -> [w,h], TQPoint -> [x,y]

	- Changed the prototypes of a couple of methods that extract values so
	  they take a KJS::ExecState parameter. This is required for us to
	  create arrays etc. in order to return complex values.

	- Began renaming the KJS::ExecState variables to 'exec' rather than
	  'state' for consistency with KJS.

	- Split the dumpObject() method into two, one that dumps the JS
	  properties, and one for the Qt properties.


2003-07-04 Friday 21:34  rich

	- Added support for passing sizes to slots. A size is represented
	  either as an array with two elements [width,height], or as an object
	  with the properties 'width' and 'height'.

	- Improved slot publishing code so that overloaded slots are
	  supported. The first slot is published as before, subsequent slots
	  with the same name get the number of arguments they require
	  appended.

	- Removed the childAt() and findChild() methods from the JSObjectProxy
	  object. The child() method provides the same facilities via a
	  unified interface.

	- Added some type information to the dump output.


2003-07-04 Friday 16:33  rich

	- Renamed the ConstructXXX constants to NewXXX.

	- Added support for reading Color, Font and KeySequence types.


2003-07-02 Wednesday 20:13  rich

	- Made slots() list slots with all signatures not just those we can
	  use as methods because we can connect to a slot even if the
	  signature is not supported.

	- Added signals() to list the signals emitted by an object.

	- Added signals and slots sections to the dump() output and
	  regenerated the JS API documentation.


2003-07-02 Wednesday 19:19  rich

	- Fixed problem with XMLActionClient caused by one of the previous
	  renaming exercises.

	- Added the ability to connect signals to signals. This is handled
	  transparently to the script, so you can simply treat the signal you
	  want to emit indirectly like the slots we already
	  support. Internally, the code will try for a slot first then try for
	  signal if that fails. This is ok because you can't have a signal and
	  a slot with the same name and signature.

	- Added a test program for the above, test_connectsignal.js.

	- Minor fixes to the tutorial.


2003-06-28 Saturday 21:09  rich

	- Added support both 3 and 4 argument forms of connect and disconnect.

	- Added a couple more examples.

	- Added support for creating TQObject and TQTimer.

	- Added some scripts to the docs directory that build a reference
	  manual for the JS API. Added the results too.


2003-06-28 Saturday 15:13  rich

	- Added support for disconnect

2003-06-28 Saturday 14:03  rich

	Added test script for connect

2003-06-28 Saturday 13:58  rich

	- Support for connect

	  - You can now connect a signal defined by one TQObject, to a slot
	    defined in another.

	- Improved the dump function:

	  - Now lists qt properties in their own section.


2003-06-28 Saturday 10:51  rich

	- Remove accidental change to Makefile.am

2003-06-28 Saturday 10:47  rich

	- Simplified the slot handling by moving the slot signature into a
	  separate variable.

	- Fixed a bug in the handling of child lookup by name (we always got
	  the first child irrespective of the name).

	- Simplified the various child lookup functions to be handled in one
	  place.

	- More simplifications of the process of implanting parameter values.

	- Protected slot invocation against being called with the wrong number
	  of arguments.

	- Update copyright dates.

	- More work on DOM support:
	  - Boolean hasAttribute( name )
	  - Value getAttribute( name )
	  - Boolean setAttribute( name, value )


2003-06-26 Thursday 20:09  rich

	- Make DOM the primary implementation

2003-06-26 Thursday 19:56  rich

	- Actually adding the bindings is likely to improve the user
	  experience. :-)


2003-06-26 Thursday 19:22  rich

	- Started adding a DOM API to the object tree. For now we'll start
	  with getElementById() to keep pmax happy. :-)


2003-06-25 Wednesday 18:17  rich

	- Fixed a bug left over from the regexp code.

2003-06-16 Monday 21:02  rich

	Oops

2003-06-16 Monday 21:02  rich

	- Added utility methods for marshalling common types and used them to
	  simplify the slot invocation code.

	- Removed a bunch of extraneous TQRegExps.

2003-06-16 Monday 20:10  rich

	- Split the addition of bindings for object proxy.

	- Added a stub class for TQObject binding classes (the stub for native
	  bindings will arrive soon).

	- Added support for TQVariant return values.


2003-06-16 Monday 11:36  staikos

	handle TQString returns properly
	also be more debuggable

2003-06-15 Sunday 22:14  rich

	- Split up the slot invocation code to make it easy to work on.

	- Added support for slot return values. The following types are
	  currently supported:

	  - bool
	  - int
	  - TQString
	  - const char *

	- Improved the self-documentation facilities.

	  - Improved the output of the dump() method.
	  - Added a classes() method that lists the available classes.


2003-06-15 Sunday 17:45  rich

	- Fixed the additional slot invocation stuff.

	- Updated changelog.

2003-06-14 Saturday 23:10  rich

	- Publish the JSEmbedPart as the global property 'part'.

	- Added the ability to run code with a specified 'this' object.
	  The default is now to run things with a null this.

	- Added an accessor for the XMLActionClient.

	- Added support for more slot signatures:

	  - mySlot(const KURL &)
	  - mySlot(int,int,int,int)

	- Improved console widget

	  - Use KLineEdit and a TDECompletion rather than a combo.
	  - Added a prompt label with a keyboard accelerator.
	  - TQTextEdit -> KTextEdit.
	  - Pass the console widget the part rather than the interpreter.

	- Provide access to the default execution context, and the ability to
	  change it.

2003-06-09 Monday 03:51  staikos

	Add support for TQObjects that can self-bind JS methods.
	Rich: this is more or less just a demo.  It's not the ideal way for this to work
	but I have not been able to find an alternative approach in JS or in C++.  We
	might be stuck with it.  Please review.  We can back it out later if a better
	solution is available.  Meanwhile, it solves my problem with StringBundle.


2003-06-07 Saturday 22:53  rich

	Added an example that displays a graphical tree

2003-06-06 Friday 13:21  staikos

	argh was not supposed to revert the last change

2003-06-06 Friday 13:19  staikos

	revert the asserts .. if people want to do this, let it crash

2003-06-06 Friday 13:09  staikos

	delete the part on exit

2003-06-06 Friday 12:33  staikos

	deparentification

	(don't crash)

2003-06-06 Friday 00:44  staikos

	assert() the crash case in here so that a developer knows it will happen before
	he gets very far

2003-06-06 Friday 00:30  staikos

	directions on how to keep it from crashing if you don't realise what it does
	with double parent objects in the constructor


2003-05-22 Thursday 17:34  geiseri

	Some fixes for makefile.am

2003-05-22 Thursday 16:56  rich


	- Fixed some problems with KJS::Identifier support.

	- Added a very basic TQPainter binding for drawing on TQPixmaps. The following
	  drawing operations are supported:

	  - void moveTo( int x, int y );
	  - void lineTo( int x, int y );
	  - void drawPoint( int x, int y );
	  - void drawLine( int x1, int y1, int x2, int y2 );
	  - void drawRect( int x, int y, int w, int h );
	  - void drawRoundRect( int x, int y, int w, int h, int = 25, int = 25 );
	  - void drawEllipse( int x, int y, int w, int h );
	  - void drawText( int x, int y, const TQString &txt );

	- Fixed a problem with the --mainwin option.

	- Added another example script.

2003-05-19 Monday 10:59  mueller

	CVS_SILENT compiler warnings

2003-04-23 Wednesday 01:21  geiseri

	Added a close button so that it could close without hitting the kill
	button.

2003-04-03 Thursday 14:55  geiseri

	KJS is mostly ported to the new api.

2003-04-03 Thursday 14:55  geiseri

	Start of DCOP support for new KJSEmbed.

2003-02-21 Friday 10:36  pmk

	Updated for changes to KJS API - use Identifier instead of UString

2003-02-04 Tuesday 17:50  rich

	- Added support for more TQWidgets:

	  TQSplitter, TQMainWindow, TQProgressDialog.

	- Improved dump() function, now spits out a nice HTML table of the
	  properties etc.

	- Renamed JSObjectProxy::jscript() to interpreter() (for consistency).

	- KJSCmd can now create a TDEMainWindow (dunno how useful this is
	  without the other additions I'm planning though).

2003-01-31 Friday 22:19  rich

	- Switched order of args to convertToVariant() to match everything
	  else.

	- Added a new global method 'dump(Object)' that returns information
	  about the specified object. The information returned depends on the
	  type of the object.

2003-01-31 Friday 19:16  rich


	- Renamed KJSEmbedPart::jscript() to KJSEmbedPart::interpreter() for
	  consistency.

	- Renamed publish() to addObject(), and publishStdBindings() to
	  addStdBindings(). This is more consistent with TQSA, and makes the
	  API more familiar to developers familiar with the rest of KDE/Qt.

2003-01-31 Friday 18:52  rich


	- Moved loadScript(filename) from main.cpp into the KPart, and renamed
	  the existing loadXX() to executeXX() which is better anyway.

	- Added -DQT_CLEAN_NAMESPACE -DQT_NO_ASCII_CAST to the build flags.

	- Added a standalone factory class. This class is responsible for
	  creating the various objects, and for creating bindings.

	- Split the code that creates the standard bindings into individual
	  methods.

	- Moved bindings classes into their own namespace KJSEmbed::Bindings,
	  this has affected the Bind_Image, Bind_TextStream, and the XXImp
	  classes.

	- Renamed SecurityPolicy to JSSecurityPolicy, and ActionData to
	  XMLActionData.

2003-01-14 Tuesday 22:35  rich

	- Remove messagelog

2003-01-14 Tuesday 22:34  rich


	- Created a KJSEmbedPartImp class which replaces the internal
	  MethodImp and ConstructorImp classes used before. This makes the
	  public header files a lot cleaner, and makes the code easier to
	  follow.

	- Created a JSObjectProxyImp class which does the same for
	  JSObjectProxy.

	- Removed the legacy isAllowed(...) methods from JSObjectProxy, use
	  the SecurityPolicy class instead.

	- Merged the reduntant class MessageLogWidget into JSConsoleWidget.

	- Moved Bind_Image and Bind_TextStream to their own files.

	- Moved the KJS::Value <-> TQVariant functions to jsbinding.

	- Improved the JSObjectProxy

	  - Tidied up the code for registering and calling slots.

	  - The slots(), properties() and children() methods now return
	    Arrays.

2003-01-14 Tuesday 15:56  rich

	- Made TQVariant <-> KJS::Value conversions standalone methods.

	- Made the argument ordering of the create() methods consistant
	  throughout.

	- Added accessor to allow you to get the TQObject a proxy is bound to.

	- Now defines constructors for all the widgets supported by the
	  TQWidgetFactory. This change is very important as it eliminates what
	  was the single most noticable difference between the C++ and
	  Javascript objects. Using constructors properly has the added bonus
	  that the Javascript interpreter can now correctly determine the
	  class of the objects.

	  - Supported Qt Widgets:

	  TQPushButton, TQToolButton, TQCheckBox, TQRadioButton,
	  TQGroupBox, TQButtonGroup, TQIconView, TQTable,
	  TQListBox, TQListView, TQLineEdit, TQSpinBox,
	  TQMultiLineEdit, TQLabel, TextLabel, PixmapLabel,
	  TQLayoutWidget, TQTabWidget, TQComboBox,
	  TQWidget, TQDialog, TQWizard, TQLCDNumber,
	  TQProgressBar, TQTextView, TQTextBrowser,
	  TQDial, TQSlider, TQFrame, Line, TQTextEdit,
	  TQDateEdit, TQTimeEdit, TQDateTimeEdit, TQScrollBar,
	  TQPopupMenu, TQWidgetStack, TQMainWindow,
	  TQDataTable, TQDataBrowser, TQDataView,
	  TQVBox, TQHBox, TQGrid

	  - Supported KDE Widgets:

	  KActiveLabel, KCharSelect, KColorButton, KColorCombo,
	  KComboBox, TDECModule, KDateWidget, KDatePicker, KDialog,
	  KDualColorButton, KEditListBox, TDEFontCombo, KGradientSelector,
	  KHistoryCombo, KHSSelector, KLed, TDEListBox, TDEListView,
	  KLineEdit, KPasswordEdit, KProgress, KPushButton,
	  KRestrictedLine, TDEIconButton, KIntSpinBox, KRuler,
	  KSqueezedTextLabel, KTextBrowser, KTextEdit,
	  KURLLabel, KURLRequester,
	  KIntNumInput, KDoubleNumInput, KDoubleSpinBox

	- Added constructors for the custom builtin objects Image and
	  TextStream.

2003-01-11 Saturday 21:50  rich

	- Added a binding to TQImage::smoothScale(w,h,ScaleMin). This should
	  really be handled by the enum property support, but as that doesn't
	  exist yet we'll do it the hard way.

	- Added a readFile(name) method to the global JS object. It returns
	  the file contents as a string, or null if the file could not be
	  read.

	- Added README files to some of the examples.

	- Added a println() method to the global object. The old print()
	  method has been changed so it no longer appends a newline.

	- Added an example that generates an image gallery.

	  - Thumbnails of the images are created automatically.

	  - Descriptions of the images are inserted in the generated page if
	    there is a file called <imgname>.htm.

	  - Automatically skips its own thumbnails.

	  - Files that aren't understood are ignored so you can just pass '*'
	    when you call it from the command line.

	  - Includes an example shellscript that ensures the images are sorted
	    by their modification time.

	- Updated copyright info.

2003-01-10 Friday 23:54  rich

	- Added Image binding.

	  - Provides a binding to some basic TQImage and TQImageIO operations.
	  - Added example that prints info about an image.
	  - Added an example that scales an image and writes it in a specified
	  - format.

	- Added support for (int, int) slots. I really need to make this code
	  handle the args generically.

	- kjscmd now makes args following the script name available to JS as
	  application.args[].

	- Strip #! line that contains kjscmd from the script so the scripts
	  can be run just by making them executable.

2003-01-06 Monday 18:23  rich

	- Added the tutorial i am working on so people can see how to use this stuff

2003-01-06 Monday 17:38  rich

	- Add link to tutorial devel site

2003-01-06 Monday 17:09  rich

	KJSEmbed 0.2
	============

	Massively updated and improved version of KJSEmbed. Still a few things
	to go though, including the tutorial.

	- Fixed i18n of js console widget

	- Fixed text spacing in console widget

	- Fixed design flaw in security model

	  The old model was flawed because sub-proxies would always revert
	  to the default policy rather than using the custom policy defined
	  by a subclass. The policy is now a standalone object, so the problem
	  is fixed.

	- Added lots of documentation and a Doxygen config file.

	- Extended factory class to create the following types:

	  - Any TQWidget sub-class
	  - TDEAction
	  - TDEToggleAction

	- Added a command line tool for invoking js scripts

	- Improved JSObjectProxy Massively

	  - Create child widgets from a script
	  - Create TDEActions and TDEToggleActions from a script
	  - Call slots from scripts

	- Added support for additional property types

2002-11-29 Friday 12:28  mueller

	backport install dir fix

2002-11-29 Friday 12:28  mueller

	install in the right path

2002-11-07 Thursday 15:30  coolo

	little cleanup

2002-03-08 Friday 13:53  rich

	kdoc fixes

2002-03-08 Friday 12:43  rich

	Updates for kjs changes in HEAD

2001-11-16 Friday 04:59  faure

	Let $(all_includes) be last otherwise my script gets unhappy ;)

2001-11-15 Thursday 14:19  mueller

	ignore

2001-11-13 Tuesday 18:38  rich

	Added an example of how to use the example. :-)

2001-11-13 Tuesday 17:12  wgreven

	Fix compililation for builddir != srcdir.

2001-11-13 Tuesday 15:56  rich

	A library for embedding kjs with transparent bindings to TQObjects and
	their properties, a dialog loader and a hook loader for client apps.

